# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from . import _utilities
from . import outputs
from ._inputs import *

__all__ = ['CatalogItemArgs', 'CatalogItem']

@pulumi.input_type
class CatalogItemArgs:
    def __init__(__self__, *,
                 catalog: pulumi.Input[str],
                 catalog_item_metadata: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]] = None,
                 description: Optional[pulumi.Input[str]] = None,
                 metadata: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]] = None,
                 metadata_entries: Optional[pulumi.Input[Sequence[pulumi.Input['CatalogItemMetadataEntryArgs']]]] = None,
                 name: Optional[pulumi.Input[str]] = None,
                 org: Optional[pulumi.Input[str]] = None,
                 ova_path: Optional[pulumi.Input[str]] = None,
                 ovf_url: Optional[pulumi.Input[str]] = None,
                 show_upload_progress: Optional[pulumi.Input[bool]] = None,
                 upload_piece_size: Optional[pulumi.Input[int]] = None):
        """
        The set of arguments for constructing a CatalogItem resource.
        :param pulumi.Input[str] catalog: The name of the catalog where to upload OVA file
        :param pulumi.Input[Mapping[str, pulumi.Input[str]]] catalog_item_metadata: Use `metadata_entry` instead.  Key value map of metadata to assign to the Catalog Item
               
               > This resource handles metadata in the following way: `metadata` attribute assigns metadata to the associated **vApp Template**.
               `metadata_entry` attribute assigns metadata to the **Catalog Item**. `catalog_item_metadata` is deprecated and should not be used.
               
               <a id="metadata"></a>
        :param pulumi.Input[str] description: Description of item
        :param pulumi.Input[Mapping[str, pulumi.Input[str]]] metadata: Key value map of metadata to assign to the associated vApp Template
        :param pulumi.Input[Sequence[pulumi.Input['CatalogItemMetadataEntryArgs']]] metadata_entries: A set of metadata entries to assign to the Catalog Item. See Metadata section for details.
        :param pulumi.Input[str] name: Item name in catalog
        :param pulumi.Input[str] org: The name of organization to use, optional if defined at provider level. Useful when connected as sysadmin working across different organisations
        :param pulumi.Input[str] ova_path: Absolute or relative path to file to upload
        :param pulumi.Input[str] ovf_url: URL to OVF file. Only OVF (not OVA) files are supported by VCD uploading by URL
        :param pulumi.Input[bool] show_upload_progress: Default false. Allows seeing upload progress. (See note below)
        :param pulumi.Input[int] upload_piece_size: Size in MB for splitting upload size. It can possibly impact upload performance. Default 1MB.
        """
        pulumi.set(__self__, "catalog", catalog)
        if catalog_item_metadata is not None:
            warnings.warn("""Use metadata_entry instead""", DeprecationWarning)
            pulumi.log.warn("""catalog_item_metadata is deprecated: Use metadata_entry instead""")
        if catalog_item_metadata is not None:
            pulumi.set(__self__, "catalog_item_metadata", catalog_item_metadata)
        if description is not None:
            pulumi.set(__self__, "description", description)
        if metadata is not None:
            pulumi.set(__self__, "metadata", metadata)
        if metadata_entries is not None:
            pulumi.set(__self__, "metadata_entries", metadata_entries)
        if name is not None:
            pulumi.set(__self__, "name", name)
        if org is not None:
            pulumi.set(__self__, "org", org)
        if ova_path is not None:
            pulumi.set(__self__, "ova_path", ova_path)
        if ovf_url is not None:
            pulumi.set(__self__, "ovf_url", ovf_url)
        if show_upload_progress is not None:
            pulumi.set(__self__, "show_upload_progress", show_upload_progress)
        if upload_piece_size is not None:
            pulumi.set(__self__, "upload_piece_size", upload_piece_size)

    @property
    @pulumi.getter
    def catalog(self) -> pulumi.Input[str]:
        """
        The name of the catalog where to upload OVA file
        """
        return pulumi.get(self, "catalog")

    @catalog.setter
    def catalog(self, value: pulumi.Input[str]):
        pulumi.set(self, "catalog", value)

    @property
    @pulumi.getter(name="catalogItemMetadata")
    @_utilities.deprecated("""Use metadata_entry instead""")
    def catalog_item_metadata(self) -> Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]]:
        """
        Use `metadata_entry` instead.  Key value map of metadata to assign to the Catalog Item

        > This resource handles metadata in the following way: `metadata` attribute assigns metadata to the associated **vApp Template**.
        `metadata_entry` attribute assigns metadata to the **Catalog Item**. `catalog_item_metadata` is deprecated and should not be used.

        <a id="metadata"></a>
        """
        return pulumi.get(self, "catalog_item_metadata")

    @catalog_item_metadata.setter
    def catalog_item_metadata(self, value: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]]):
        pulumi.set(self, "catalog_item_metadata", value)

    @property
    @pulumi.getter
    def description(self) -> Optional[pulumi.Input[str]]:
        """
        Description of item
        """
        return pulumi.get(self, "description")

    @description.setter
    def description(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "description", value)

    @property
    @pulumi.getter
    def metadata(self) -> Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]]:
        """
        Key value map of metadata to assign to the associated vApp Template
        """
        return pulumi.get(self, "metadata")

    @metadata.setter
    def metadata(self, value: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]]):
        pulumi.set(self, "metadata", value)

    @property
    @pulumi.getter(name="metadataEntries")
    def metadata_entries(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['CatalogItemMetadataEntryArgs']]]]:
        """
        A set of metadata entries to assign to the Catalog Item. See Metadata section for details.
        """
        return pulumi.get(self, "metadata_entries")

    @metadata_entries.setter
    def metadata_entries(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['CatalogItemMetadataEntryArgs']]]]):
        pulumi.set(self, "metadata_entries", value)

    @property
    @pulumi.getter
    def name(self) -> Optional[pulumi.Input[str]]:
        """
        Item name in catalog
        """
        return pulumi.get(self, "name")

    @name.setter
    def name(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "name", value)

    @property
    @pulumi.getter
    def org(self) -> Optional[pulumi.Input[str]]:
        """
        The name of organization to use, optional if defined at provider level. Useful when connected as sysadmin working across different organisations
        """
        return pulumi.get(self, "org")

    @org.setter
    def org(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "org", value)

    @property
    @pulumi.getter(name="ovaPath")
    def ova_path(self) -> Optional[pulumi.Input[str]]:
        """
        Absolute or relative path to file to upload
        """
        return pulumi.get(self, "ova_path")

    @ova_path.setter
    def ova_path(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "ova_path", value)

    @property
    @pulumi.getter(name="ovfUrl")
    def ovf_url(self) -> Optional[pulumi.Input[str]]:
        """
        URL to OVF file. Only OVF (not OVA) files are supported by VCD uploading by URL
        """
        return pulumi.get(self, "ovf_url")

    @ovf_url.setter
    def ovf_url(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "ovf_url", value)

    @property
    @pulumi.getter(name="showUploadProgress")
    def show_upload_progress(self) -> Optional[pulumi.Input[bool]]:
        """
        Default false. Allows seeing upload progress. (See note below)
        """
        return pulumi.get(self, "show_upload_progress")

    @show_upload_progress.setter
    def show_upload_progress(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "show_upload_progress", value)

    @property
    @pulumi.getter(name="uploadPieceSize")
    def upload_piece_size(self) -> Optional[pulumi.Input[int]]:
        """
        Size in MB for splitting upload size. It can possibly impact upload performance. Default 1MB.
        """
        return pulumi.get(self, "upload_piece_size")

    @upload_piece_size.setter
    def upload_piece_size(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "upload_piece_size", value)


@pulumi.input_type
class _CatalogItemState:
    def __init__(__self__, *,
                 catalog: Optional[pulumi.Input[str]] = None,
                 catalog_item_metadata: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]] = None,
                 created: Optional[pulumi.Input[str]] = None,
                 description: Optional[pulumi.Input[str]] = None,
                 metadata: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]] = None,
                 metadata_entries: Optional[pulumi.Input[Sequence[pulumi.Input['CatalogItemMetadataEntryArgs']]]] = None,
                 name: Optional[pulumi.Input[str]] = None,
                 org: Optional[pulumi.Input[str]] = None,
                 ova_path: Optional[pulumi.Input[str]] = None,
                 ovf_url: Optional[pulumi.Input[str]] = None,
                 show_upload_progress: Optional[pulumi.Input[bool]] = None,
                 upload_piece_size: Optional[pulumi.Input[int]] = None):
        """
        Input properties used for looking up and filtering CatalogItem resources.
        :param pulumi.Input[str] catalog: The name of the catalog where to upload OVA file
        :param pulumi.Input[Mapping[str, pulumi.Input[str]]] catalog_item_metadata: Use `metadata_entry` instead.  Key value map of metadata to assign to the Catalog Item
               
               > This resource handles metadata in the following way: `metadata` attribute assigns metadata to the associated **vApp Template**.
               `metadata_entry` attribute assigns metadata to the **Catalog Item**. `catalog_item_metadata` is deprecated and should not be used.
               
               <a id="metadata"></a>
        :param pulumi.Input[str] created: Time stamp of when the item was created
        :param pulumi.Input[str] description: Description of item
        :param pulumi.Input[Mapping[str, pulumi.Input[str]]] metadata: Key value map of metadata to assign to the associated vApp Template
        :param pulumi.Input[Sequence[pulumi.Input['CatalogItemMetadataEntryArgs']]] metadata_entries: A set of metadata entries to assign to the Catalog Item. See Metadata section for details.
        :param pulumi.Input[str] name: Item name in catalog
        :param pulumi.Input[str] org: The name of organization to use, optional if defined at provider level. Useful when connected as sysadmin working across different organisations
        :param pulumi.Input[str] ova_path: Absolute or relative path to file to upload
        :param pulumi.Input[str] ovf_url: URL to OVF file. Only OVF (not OVA) files are supported by VCD uploading by URL
        :param pulumi.Input[bool] show_upload_progress: Default false. Allows seeing upload progress. (See note below)
        :param pulumi.Input[int] upload_piece_size: Size in MB for splitting upload size. It can possibly impact upload performance. Default 1MB.
        """
        if catalog is not None:
            pulumi.set(__self__, "catalog", catalog)
        if catalog_item_metadata is not None:
            warnings.warn("""Use metadata_entry instead""", DeprecationWarning)
            pulumi.log.warn("""catalog_item_metadata is deprecated: Use metadata_entry instead""")
        if catalog_item_metadata is not None:
            pulumi.set(__self__, "catalog_item_metadata", catalog_item_metadata)
        if created is not None:
            pulumi.set(__self__, "created", created)
        if description is not None:
            pulumi.set(__self__, "description", description)
        if metadata is not None:
            pulumi.set(__self__, "metadata", metadata)
        if metadata_entries is not None:
            pulumi.set(__self__, "metadata_entries", metadata_entries)
        if name is not None:
            pulumi.set(__self__, "name", name)
        if org is not None:
            pulumi.set(__self__, "org", org)
        if ova_path is not None:
            pulumi.set(__self__, "ova_path", ova_path)
        if ovf_url is not None:
            pulumi.set(__self__, "ovf_url", ovf_url)
        if show_upload_progress is not None:
            pulumi.set(__self__, "show_upload_progress", show_upload_progress)
        if upload_piece_size is not None:
            pulumi.set(__self__, "upload_piece_size", upload_piece_size)

    @property
    @pulumi.getter
    def catalog(self) -> Optional[pulumi.Input[str]]:
        """
        The name of the catalog where to upload OVA file
        """
        return pulumi.get(self, "catalog")

    @catalog.setter
    def catalog(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "catalog", value)

    @property
    @pulumi.getter(name="catalogItemMetadata")
    @_utilities.deprecated("""Use metadata_entry instead""")
    def catalog_item_metadata(self) -> Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]]:
        """
        Use `metadata_entry` instead.  Key value map of metadata to assign to the Catalog Item

        > This resource handles metadata in the following way: `metadata` attribute assigns metadata to the associated **vApp Template**.
        `metadata_entry` attribute assigns metadata to the **Catalog Item**. `catalog_item_metadata` is deprecated and should not be used.

        <a id="metadata"></a>
        """
        return pulumi.get(self, "catalog_item_metadata")

    @catalog_item_metadata.setter
    def catalog_item_metadata(self, value: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]]):
        pulumi.set(self, "catalog_item_metadata", value)

    @property
    @pulumi.getter
    def created(self) -> Optional[pulumi.Input[str]]:
        """
        Time stamp of when the item was created
        """
        return pulumi.get(self, "created")

    @created.setter
    def created(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "created", value)

    @property
    @pulumi.getter
    def description(self) -> Optional[pulumi.Input[str]]:
        """
        Description of item
        """
        return pulumi.get(self, "description")

    @description.setter
    def description(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "description", value)

    @property
    @pulumi.getter
    def metadata(self) -> Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]]:
        """
        Key value map of metadata to assign to the associated vApp Template
        """
        return pulumi.get(self, "metadata")

    @metadata.setter
    def metadata(self, value: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]]):
        pulumi.set(self, "metadata", value)

    @property
    @pulumi.getter(name="metadataEntries")
    def metadata_entries(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['CatalogItemMetadataEntryArgs']]]]:
        """
        A set of metadata entries to assign to the Catalog Item. See Metadata section for details.
        """
        return pulumi.get(self, "metadata_entries")

    @metadata_entries.setter
    def metadata_entries(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['CatalogItemMetadataEntryArgs']]]]):
        pulumi.set(self, "metadata_entries", value)

    @property
    @pulumi.getter
    def name(self) -> Optional[pulumi.Input[str]]:
        """
        Item name in catalog
        """
        return pulumi.get(self, "name")

    @name.setter
    def name(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "name", value)

    @property
    @pulumi.getter
    def org(self) -> Optional[pulumi.Input[str]]:
        """
        The name of organization to use, optional if defined at provider level. Useful when connected as sysadmin working across different organisations
        """
        return pulumi.get(self, "org")

    @org.setter
    def org(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "org", value)

    @property
    @pulumi.getter(name="ovaPath")
    def ova_path(self) -> Optional[pulumi.Input[str]]:
        """
        Absolute or relative path to file to upload
        """
        return pulumi.get(self, "ova_path")

    @ova_path.setter
    def ova_path(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "ova_path", value)

    @property
    @pulumi.getter(name="ovfUrl")
    def ovf_url(self) -> Optional[pulumi.Input[str]]:
        """
        URL to OVF file. Only OVF (not OVA) files are supported by VCD uploading by URL
        """
        return pulumi.get(self, "ovf_url")

    @ovf_url.setter
    def ovf_url(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "ovf_url", value)

    @property
    @pulumi.getter(name="showUploadProgress")
    def show_upload_progress(self) -> Optional[pulumi.Input[bool]]:
        """
        Default false. Allows seeing upload progress. (See note below)
        """
        return pulumi.get(self, "show_upload_progress")

    @show_upload_progress.setter
    def show_upload_progress(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "show_upload_progress", value)

    @property
    @pulumi.getter(name="uploadPieceSize")
    def upload_piece_size(self) -> Optional[pulumi.Input[int]]:
        """
        Size in MB for splitting upload size. It can possibly impact upload performance. Default 1MB.
        """
        return pulumi.get(self, "upload_piece_size")

    @upload_piece_size.setter
    def upload_piece_size(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "upload_piece_size", value)


class CatalogItem(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 catalog: Optional[pulumi.Input[str]] = None,
                 catalog_item_metadata: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]] = None,
                 description: Optional[pulumi.Input[str]] = None,
                 metadata: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]] = None,
                 metadata_entries: Optional[pulumi.Input[Sequence[pulumi.Input[Union['CatalogItemMetadataEntryArgs', 'CatalogItemMetadataEntryArgsDict']]]]] = None,
                 name: Optional[pulumi.Input[str]] = None,
                 org: Optional[pulumi.Input[str]] = None,
                 ova_path: Optional[pulumi.Input[str]] = None,
                 ovf_url: Optional[pulumi.Input[str]] = None,
                 show_upload_progress: Optional[pulumi.Input[bool]] = None,
                 upload_piece_size: Optional[pulumi.Input[int]] = None,
                 __props__=None):
        """
        Create a CatalogItem resource with the given unique name, props, and options.
        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] catalog: The name of the catalog where to upload OVA file
        :param pulumi.Input[Mapping[str, pulumi.Input[str]]] catalog_item_metadata: Use `metadata_entry` instead.  Key value map of metadata to assign to the Catalog Item
               
               > This resource handles metadata in the following way: `metadata` attribute assigns metadata to the associated **vApp Template**.
               `metadata_entry` attribute assigns metadata to the **Catalog Item**. `catalog_item_metadata` is deprecated and should not be used.
               
               <a id="metadata"></a>
        :param pulumi.Input[str] description: Description of item
        :param pulumi.Input[Mapping[str, pulumi.Input[str]]] metadata: Key value map of metadata to assign to the associated vApp Template
        :param pulumi.Input[Sequence[pulumi.Input[Union['CatalogItemMetadataEntryArgs', 'CatalogItemMetadataEntryArgsDict']]]] metadata_entries: A set of metadata entries to assign to the Catalog Item. See Metadata section for details.
        :param pulumi.Input[str] name: Item name in catalog
        :param pulumi.Input[str] org: The name of organization to use, optional if defined at provider level. Useful when connected as sysadmin working across different organisations
        :param pulumi.Input[str] ova_path: Absolute or relative path to file to upload
        :param pulumi.Input[str] ovf_url: URL to OVF file. Only OVF (not OVA) files are supported by VCD uploading by URL
        :param pulumi.Input[bool] show_upload_progress: Default false. Allows seeing upload progress. (See note below)
        :param pulumi.Input[int] upload_piece_size: Size in MB for splitting upload size. It can possibly impact upload performance. Default 1MB.
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: CatalogItemArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        Create a CatalogItem resource with the given unique name, props, and options.
        :param str resource_name: The name of the resource.
        :param CatalogItemArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(CatalogItemArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 catalog: Optional[pulumi.Input[str]] = None,
                 catalog_item_metadata: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]] = None,
                 description: Optional[pulumi.Input[str]] = None,
                 metadata: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]] = None,
                 metadata_entries: Optional[pulumi.Input[Sequence[pulumi.Input[Union['CatalogItemMetadataEntryArgs', 'CatalogItemMetadataEntryArgsDict']]]]] = None,
                 name: Optional[pulumi.Input[str]] = None,
                 org: Optional[pulumi.Input[str]] = None,
                 ova_path: Optional[pulumi.Input[str]] = None,
                 ovf_url: Optional[pulumi.Input[str]] = None,
                 show_upload_progress: Optional[pulumi.Input[bool]] = None,
                 upload_piece_size: Optional[pulumi.Input[int]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = CatalogItemArgs.__new__(CatalogItemArgs)

            if catalog is None and not opts.urn:
                raise TypeError("Missing required property 'catalog'")
            __props__.__dict__["catalog"] = catalog
            __props__.__dict__["catalog_item_metadata"] = catalog_item_metadata
            __props__.__dict__["description"] = description
            __props__.__dict__["metadata"] = metadata
            __props__.__dict__["metadata_entries"] = metadata_entries
            __props__.__dict__["name"] = name
            __props__.__dict__["org"] = org
            __props__.__dict__["ova_path"] = ova_path
            __props__.__dict__["ovf_url"] = ovf_url
            __props__.__dict__["show_upload_progress"] = show_upload_progress
            __props__.__dict__["upload_piece_size"] = upload_piece_size
            __props__.__dict__["created"] = None
        super(CatalogItem, __self__).__init__(
            'vcd:index/catalogItem:CatalogItem',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            catalog: Optional[pulumi.Input[str]] = None,
            catalog_item_metadata: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]] = None,
            created: Optional[pulumi.Input[str]] = None,
            description: Optional[pulumi.Input[str]] = None,
            metadata: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]] = None,
            metadata_entries: Optional[pulumi.Input[Sequence[pulumi.Input[Union['CatalogItemMetadataEntryArgs', 'CatalogItemMetadataEntryArgsDict']]]]] = None,
            name: Optional[pulumi.Input[str]] = None,
            org: Optional[pulumi.Input[str]] = None,
            ova_path: Optional[pulumi.Input[str]] = None,
            ovf_url: Optional[pulumi.Input[str]] = None,
            show_upload_progress: Optional[pulumi.Input[bool]] = None,
            upload_piece_size: Optional[pulumi.Input[int]] = None) -> 'CatalogItem':
        """
        Get an existing CatalogItem resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] catalog: The name of the catalog where to upload OVA file
        :param pulumi.Input[Mapping[str, pulumi.Input[str]]] catalog_item_metadata: Use `metadata_entry` instead.  Key value map of metadata to assign to the Catalog Item
               
               > This resource handles metadata in the following way: `metadata` attribute assigns metadata to the associated **vApp Template**.
               `metadata_entry` attribute assigns metadata to the **Catalog Item**. `catalog_item_metadata` is deprecated and should not be used.
               
               <a id="metadata"></a>
        :param pulumi.Input[str] created: Time stamp of when the item was created
        :param pulumi.Input[str] description: Description of item
        :param pulumi.Input[Mapping[str, pulumi.Input[str]]] metadata: Key value map of metadata to assign to the associated vApp Template
        :param pulumi.Input[Sequence[pulumi.Input[Union['CatalogItemMetadataEntryArgs', 'CatalogItemMetadataEntryArgsDict']]]] metadata_entries: A set of metadata entries to assign to the Catalog Item. See Metadata section for details.
        :param pulumi.Input[str] name: Item name in catalog
        :param pulumi.Input[str] org: The name of organization to use, optional if defined at provider level. Useful when connected as sysadmin working across different organisations
        :param pulumi.Input[str] ova_path: Absolute or relative path to file to upload
        :param pulumi.Input[str] ovf_url: URL to OVF file. Only OVF (not OVA) files are supported by VCD uploading by URL
        :param pulumi.Input[bool] show_upload_progress: Default false. Allows seeing upload progress. (See note below)
        :param pulumi.Input[int] upload_piece_size: Size in MB for splitting upload size. It can possibly impact upload performance. Default 1MB.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = _CatalogItemState.__new__(_CatalogItemState)

        __props__.__dict__["catalog"] = catalog
        __props__.__dict__["catalog_item_metadata"] = catalog_item_metadata
        __props__.__dict__["created"] = created
        __props__.__dict__["description"] = description
        __props__.__dict__["metadata"] = metadata
        __props__.__dict__["metadata_entries"] = metadata_entries
        __props__.__dict__["name"] = name
        __props__.__dict__["org"] = org
        __props__.__dict__["ova_path"] = ova_path
        __props__.__dict__["ovf_url"] = ovf_url
        __props__.__dict__["show_upload_progress"] = show_upload_progress
        __props__.__dict__["upload_piece_size"] = upload_piece_size
        return CatalogItem(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter
    def catalog(self) -> pulumi.Output[str]:
        """
        The name of the catalog where to upload OVA file
        """
        return pulumi.get(self, "catalog")

    @property
    @pulumi.getter(name="catalogItemMetadata")
    @_utilities.deprecated("""Use metadata_entry instead""")
    def catalog_item_metadata(self) -> pulumi.Output[Mapping[str, str]]:
        """
        Use `metadata_entry` instead.  Key value map of metadata to assign to the Catalog Item

        > This resource handles metadata in the following way: `metadata` attribute assigns metadata to the associated **vApp Template**.
        `metadata_entry` attribute assigns metadata to the **Catalog Item**. `catalog_item_metadata` is deprecated and should not be used.

        <a id="metadata"></a>
        """
        return pulumi.get(self, "catalog_item_metadata")

    @property
    @pulumi.getter
    def created(self) -> pulumi.Output[str]:
        """
        Time stamp of when the item was created
        """
        return pulumi.get(self, "created")

    @property
    @pulumi.getter
    def description(self) -> pulumi.Output[Optional[str]]:
        """
        Description of item
        """
        return pulumi.get(self, "description")

    @property
    @pulumi.getter
    def metadata(self) -> pulumi.Output[Optional[Mapping[str, str]]]:
        """
        Key value map of metadata to assign to the associated vApp Template
        """
        return pulumi.get(self, "metadata")

    @property
    @pulumi.getter(name="metadataEntries")
    def metadata_entries(self) -> pulumi.Output[Sequence['outputs.CatalogItemMetadataEntry']]:
        """
        A set of metadata entries to assign to the Catalog Item. See Metadata section for details.
        """
        return pulumi.get(self, "metadata_entries")

    @property
    @pulumi.getter
    def name(self) -> pulumi.Output[str]:
        """
        Item name in catalog
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter
    def org(self) -> pulumi.Output[Optional[str]]:
        """
        The name of organization to use, optional if defined at provider level. Useful when connected as sysadmin working across different organisations
        """
        return pulumi.get(self, "org")

    @property
    @pulumi.getter(name="ovaPath")
    def ova_path(self) -> pulumi.Output[Optional[str]]:
        """
        Absolute or relative path to file to upload
        """
        return pulumi.get(self, "ova_path")

    @property
    @pulumi.getter(name="ovfUrl")
    def ovf_url(self) -> pulumi.Output[Optional[str]]:
        """
        URL to OVF file. Only OVF (not OVA) files are supported by VCD uploading by URL
        """
        return pulumi.get(self, "ovf_url")

    @property
    @pulumi.getter(name="showUploadProgress")
    def show_upload_progress(self) -> pulumi.Output[Optional[bool]]:
        """
        Default false. Allows seeing upload progress. (See note below)
        """
        return pulumi.get(self, "show_upload_progress")

    @property
    @pulumi.getter(name="uploadPieceSize")
    def upload_piece_size(self) -> pulumi.Output[Optional[int]]:
        """
        Size in MB for splitting upload size. It can possibly impact upload performance. Default 1MB.
        """
        return pulumi.get(self, "upload_piece_size")

