# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from . import _utilities

__all__ = [
    'GetGlobalRoleResult',
    'AwaitableGetGlobalRoleResult',
    'get_global_role',
    'get_global_role_output',
]

@pulumi.output_type
class GetGlobalRoleResult:
    """
    A collection of values returned by getGlobalRole.
    """
    def __init__(__self__, bundle_key=None, description=None, id=None, name=None, publish_to_all_tenants=None, read_only=None, rights=None, tenants=None):
        if bundle_key and not isinstance(bundle_key, str):
            raise TypeError("Expected argument 'bundle_key' to be a str")
        pulumi.set(__self__, "bundle_key", bundle_key)
        if description and not isinstance(description, str):
            raise TypeError("Expected argument 'description' to be a str")
        pulumi.set(__self__, "description", description)
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if name and not isinstance(name, str):
            raise TypeError("Expected argument 'name' to be a str")
        pulumi.set(__self__, "name", name)
        if publish_to_all_tenants and not isinstance(publish_to_all_tenants, bool):
            raise TypeError("Expected argument 'publish_to_all_tenants' to be a bool")
        pulumi.set(__self__, "publish_to_all_tenants", publish_to_all_tenants)
        if read_only and not isinstance(read_only, bool):
            raise TypeError("Expected argument 'read_only' to be a bool")
        pulumi.set(__self__, "read_only", read_only)
        if rights and not isinstance(rights, list):
            raise TypeError("Expected argument 'rights' to be a list")
        pulumi.set(__self__, "rights", rights)
        if tenants and not isinstance(tenants, list):
            raise TypeError("Expected argument 'tenants' to be a list")
        pulumi.set(__self__, "tenants", tenants)

    @property
    @pulumi.getter(name="bundleKey")
    def bundle_key(self) -> str:
        """
        Key used for internationalization.
        """
        return pulumi.get(self, "bundle_key")

    @property
    @pulumi.getter
    def description(self) -> str:
        """
        A description of the global role
        """
        return pulumi.get(self, "description")

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        The provider-assigned unique ID for this managed resource.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter
    def name(self) -> str:
        return pulumi.get(self, "name")

    @property
    @pulumi.getter(name="publishToAllTenants")
    def publish_to_all_tenants(self) -> bool:
        """
        When true, publishes the global role to all tenants
        """
        return pulumi.get(self, "publish_to_all_tenants")

    @property
    @pulumi.getter(name="readOnly")
    def read_only(self) -> bool:
        """
        Whether this global role is read-only
        """
        return pulumi.get(self, "read_only")

    @property
    @pulumi.getter
    def rights(self) -> Sequence[str]:
        """
        List of rights assigned to this role
        """
        return pulumi.get(self, "rights")

    @property
    @pulumi.getter
    def tenants(self) -> Sequence[str]:
        """
        List of tenants to which this global role gets published. Ignored if `publish_to_all_tenants` is true.
        """
        return pulumi.get(self, "tenants")


class AwaitableGetGlobalRoleResult(GetGlobalRoleResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetGlobalRoleResult(
            bundle_key=self.bundle_key,
            description=self.description,
            id=self.id,
            name=self.name,
            publish_to_all_tenants=self.publish_to_all_tenants,
            read_only=self.read_only,
            rights=self.rights,
            tenants=self.tenants)


def get_global_role(name: Optional[str] = None,
                    opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetGlobalRoleResult:
    """
    Provides a VMware Cloud Director global role data source. This can be used to read global roles.

    Supported in provider *v3.3+*

    ## Example Usage

    ```python
    import pulumi
    import pulumi_vcd as vcd

    vapp_author = vcd.get_global_role(name="vApp Author")
    ```

    ## More information

    See [Roles management](https://www.terraform.io/providers/vmware/vcd/latest/docs/guides/roles_management) for a broader description of how global roles and
    rights work together.


    :param str name: The name of the global role.
    """
    __args__ = dict()
    __args__['name'] = name
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('vcd:index/getGlobalRole:getGlobalRole', __args__, opts=opts, typ=GetGlobalRoleResult).value

    return AwaitableGetGlobalRoleResult(
        bundle_key=pulumi.get(__ret__, 'bundle_key'),
        description=pulumi.get(__ret__, 'description'),
        id=pulumi.get(__ret__, 'id'),
        name=pulumi.get(__ret__, 'name'),
        publish_to_all_tenants=pulumi.get(__ret__, 'publish_to_all_tenants'),
        read_only=pulumi.get(__ret__, 'read_only'),
        rights=pulumi.get(__ret__, 'rights'),
        tenants=pulumi.get(__ret__, 'tenants'))
def get_global_role_output(name: Optional[pulumi.Input[str]] = None,
                           opts: Optional[Union[pulumi.InvokeOptions, pulumi.InvokeOutputOptions]] = None) -> pulumi.Output[GetGlobalRoleResult]:
    """
    Provides a VMware Cloud Director global role data source. This can be used to read global roles.

    Supported in provider *v3.3+*

    ## Example Usage

    ```python
    import pulumi
    import pulumi_vcd as vcd

    vapp_author = vcd.get_global_role(name="vApp Author")
    ```

    ## More information

    See [Roles management](https://www.terraform.io/providers/vmware/vcd/latest/docs/guides/roles_management) for a broader description of how global roles and
    rights work together.


    :param str name: The name of the global role.
    """
    __args__ = dict()
    __args__['name'] = name
    opts = pulumi.InvokeOutputOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke_output('vcd:index/getGlobalRole:getGlobalRole', __args__, opts=opts, typ=GetGlobalRoleResult)
    return __ret__.apply(lambda __response__: GetGlobalRoleResult(
        bundle_key=pulumi.get(__response__, 'bundle_key'),
        description=pulumi.get(__response__, 'description'),
        id=pulumi.get(__response__, 'id'),
        name=pulumi.get(__response__, 'name'),
        publish_to_all_tenants=pulumi.get(__response__, 'publish_to_all_tenants'),
        read_only=pulumi.get(__response__, 'read_only'),
        rights=pulumi.get(__response__, 'rights'),
        tenants=pulumi.get(__response__, 'tenants')))
