# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from . import _utilities

__all__ = [
    'GetNsxtAlbImportableCloudResult',
    'AwaitableGetNsxtAlbImportableCloudResult',
    'get_nsxt_alb_importable_cloud',
    'get_nsxt_alb_importable_cloud_output',
]

@pulumi.output_type
class GetNsxtAlbImportableCloudResult:
    """
    A collection of values returned by getNsxtAlbImportableCloud.
    """
    def __init__(__self__, already_imported=None, controller_id=None, id=None, name=None, network_pool_id=None, network_pool_name=None, transport_zone_name=None):
        if already_imported and not isinstance(already_imported, bool):
            raise TypeError("Expected argument 'already_imported' to be a bool")
        pulumi.set(__self__, "already_imported", already_imported)
        if controller_id and not isinstance(controller_id, str):
            raise TypeError("Expected argument 'controller_id' to be a str")
        pulumi.set(__self__, "controller_id", controller_id)
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if name and not isinstance(name, str):
            raise TypeError("Expected argument 'name' to be a str")
        pulumi.set(__self__, "name", name)
        if network_pool_id and not isinstance(network_pool_id, str):
            raise TypeError("Expected argument 'network_pool_id' to be a str")
        pulumi.set(__self__, "network_pool_id", network_pool_id)
        if network_pool_name and not isinstance(network_pool_name, str):
            raise TypeError("Expected argument 'network_pool_name' to be a str")
        pulumi.set(__self__, "network_pool_name", network_pool_name)
        if transport_zone_name and not isinstance(transport_zone_name, str):
            raise TypeError("Expected argument 'transport_zone_name' to be a str")
        pulumi.set(__self__, "transport_zone_name", transport_zone_name)

    @property
    @pulumi.getter(name="alreadyImported")
    def already_imported(self) -> bool:
        """
        boolean value which displays if the ALB Importable Cloud is already consumed
        """
        return pulumi.get(self, "already_imported")

    @property
    @pulumi.getter(name="controllerId")
    def controller_id(self) -> str:
        return pulumi.get(self, "controller_id")

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        The provider-assigned unique ID for this managed resource.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter
    def name(self) -> str:
        return pulumi.get(self, "name")

    @property
    @pulumi.getter(name="networkPoolId")
    def network_pool_id(self) -> str:
        """
        backing network pool ID
        """
        return pulumi.get(self, "network_pool_id")

    @property
    @pulumi.getter(name="networkPoolName")
    def network_pool_name(self) -> str:
        """
        backing network pool ID
        """
        return pulumi.get(self, "network_pool_name")

    @property
    @pulumi.getter(name="transportZoneName")
    def transport_zone_name(self) -> str:
        """
        backing transport zone name
        """
        return pulumi.get(self, "transport_zone_name")


class AwaitableGetNsxtAlbImportableCloudResult(GetNsxtAlbImportableCloudResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetNsxtAlbImportableCloudResult(
            already_imported=self.already_imported,
            controller_id=self.controller_id,
            id=self.id,
            name=self.name,
            network_pool_id=self.network_pool_id,
            network_pool_name=self.network_pool_name,
            transport_zone_name=self.transport_zone_name)


def get_nsxt_alb_importable_cloud(controller_id: Optional[str] = None,
                                  name: Optional[str] = None,
                                  opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetNsxtAlbImportableCloudResult:
    """
    Supported in provider *v3.4+* and VCD 10.2+ with NSX-T and ALB.

    Provides a data source to reference existing ALB Importable Clouds. An NSX-T Importable Cloud is a reference to a
    Cloud configured in ALB Controller.

    > Only `System Administrator` can use this data source.

    > VCD 10.3.0 has a caching bug which prevents listing importable clouds immediately after [ALB
    Controller](https://www.terraform.io/providers/vmware/vcd/latest/docs/resources/nsxt_alb_controller) is created. This data should be
    available 15 minutes after the Controller is created.

    ## Example Usage

    ```python
    import pulumi
    import pulumi_vcd as vcd

    first = vcd.get_nsxt_alb_controller(name="alb-controller")
    cld = vcd.get_nsxt_alb_importable_cloud(name="NSXT Importable Cloud",
        controller_id=first.id)
    ```


    :param str controller_id: ALB Controller ID
    :param str name: Name of ALB Importable Cloud
    """
    __args__ = dict()
    __args__['controllerId'] = controller_id
    __args__['name'] = name
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('vcd:index/getNsxtAlbImportableCloud:getNsxtAlbImportableCloud', __args__, opts=opts, typ=GetNsxtAlbImportableCloudResult).value

    return AwaitableGetNsxtAlbImportableCloudResult(
        already_imported=pulumi.get(__ret__, 'already_imported'),
        controller_id=pulumi.get(__ret__, 'controller_id'),
        id=pulumi.get(__ret__, 'id'),
        name=pulumi.get(__ret__, 'name'),
        network_pool_id=pulumi.get(__ret__, 'network_pool_id'),
        network_pool_name=pulumi.get(__ret__, 'network_pool_name'),
        transport_zone_name=pulumi.get(__ret__, 'transport_zone_name'))
def get_nsxt_alb_importable_cloud_output(controller_id: Optional[pulumi.Input[str]] = None,
                                         name: Optional[pulumi.Input[str]] = None,
                                         opts: Optional[Union[pulumi.InvokeOptions, pulumi.InvokeOutputOptions]] = None) -> pulumi.Output[GetNsxtAlbImportableCloudResult]:
    """
    Supported in provider *v3.4+* and VCD 10.2+ with NSX-T and ALB.

    Provides a data source to reference existing ALB Importable Clouds. An NSX-T Importable Cloud is a reference to a
    Cloud configured in ALB Controller.

    > Only `System Administrator` can use this data source.

    > VCD 10.3.0 has a caching bug which prevents listing importable clouds immediately after [ALB
    Controller](https://www.terraform.io/providers/vmware/vcd/latest/docs/resources/nsxt_alb_controller) is created. This data should be
    available 15 minutes after the Controller is created.

    ## Example Usage

    ```python
    import pulumi
    import pulumi_vcd as vcd

    first = vcd.get_nsxt_alb_controller(name="alb-controller")
    cld = vcd.get_nsxt_alb_importable_cloud(name="NSXT Importable Cloud",
        controller_id=first.id)
    ```


    :param str controller_id: ALB Controller ID
    :param str name: Name of ALB Importable Cloud
    """
    __args__ = dict()
    __args__['controllerId'] = controller_id
    __args__['name'] = name
    opts = pulumi.InvokeOutputOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke_output('vcd:index/getNsxtAlbImportableCloud:getNsxtAlbImportableCloud', __args__, opts=opts, typ=GetNsxtAlbImportableCloudResult)
    return __ret__.apply(lambda __response__: GetNsxtAlbImportableCloudResult(
        already_imported=pulumi.get(__response__, 'already_imported'),
        controller_id=pulumi.get(__response__, 'controller_id'),
        id=pulumi.get(__response__, 'id'),
        name=pulumi.get(__response__, 'name'),
        network_pool_id=pulumi.get(__response__, 'network_pool_id'),
        network_pool_name=pulumi.get(__response__, 'network_pool_name'),
        transport_zone_name=pulumi.get(__response__, 'transport_zone_name')))
