# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from . import _utilities

__all__ = [
    'GetNsxtEdgegatewayDhcpv6Result',
    'AwaitableGetNsxtEdgegatewayDhcpv6Result',
    'get_nsxt_edgegateway_dhcpv6',
    'get_nsxt_edgegateway_dhcpv6_output',
]

@pulumi.output_type
class GetNsxtEdgegatewayDhcpv6Result:
    """
    A collection of values returned by getNsxtEdgegatewayDhcpv6.
    """
    def __init__(__self__, dns_servers=None, domain_names=None, edge_gateway_id=None, id=None, mode=None, org=None):
        if dns_servers and not isinstance(dns_servers, list):
            raise TypeError("Expected argument 'dns_servers' to be a list")
        pulumi.set(__self__, "dns_servers", dns_servers)
        if domain_names and not isinstance(domain_names, list):
            raise TypeError("Expected argument 'domain_names' to be a list")
        pulumi.set(__self__, "domain_names", domain_names)
        if edge_gateway_id and not isinstance(edge_gateway_id, str):
            raise TypeError("Expected argument 'edge_gateway_id' to be a str")
        pulumi.set(__self__, "edge_gateway_id", edge_gateway_id)
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if mode and not isinstance(mode, str):
            raise TypeError("Expected argument 'mode' to be a str")
        pulumi.set(__self__, "mode", mode)
        if org and not isinstance(org, str):
            raise TypeError("Expected argument 'org' to be a str")
        pulumi.set(__self__, "org", org)

    @property
    @pulumi.getter(name="dnsServers")
    def dns_servers(self) -> Sequence[str]:
        return pulumi.get(self, "dns_servers")

    @property
    @pulumi.getter(name="domainNames")
    def domain_names(self) -> Sequence[str]:
        return pulumi.get(self, "domain_names")

    @property
    @pulumi.getter(name="edgeGatewayId")
    def edge_gateway_id(self) -> str:
        return pulumi.get(self, "edge_gateway_id")

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        The provider-assigned unique ID for this managed resource.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter
    def mode(self) -> str:
        return pulumi.get(self, "mode")

    @property
    @pulumi.getter
    def org(self) -> Optional[str]:
        return pulumi.get(self, "org")


class AwaitableGetNsxtEdgegatewayDhcpv6Result(GetNsxtEdgegatewayDhcpv6Result):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetNsxtEdgegatewayDhcpv6Result(
            dns_servers=self.dns_servers,
            domain_names=self.domain_names,
            edge_gateway_id=self.edge_gateway_id,
            id=self.id,
            mode=self.mode,
            org=self.org)


def get_nsxt_edgegateway_dhcpv6(edge_gateway_id: Optional[str] = None,
                                org: Optional[str] = None,
                                opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetNsxtEdgegatewayDhcpv6Result:
    """
    Provides a data source to read DHCPv6 configuration for NSX-T Edge Gateways.

    ## Example Usage

    ```python
    import pulumi
    import pulumi_vcd as vcd

    testing_in_vdc = vcd.get_nsxt_edgegateway_dhcpv6(org="datacloud",
        edge_gateway_id=testing_in_vdc_vcd_nsxt_edgegateway["id"])
    ```


    :param str edge_gateway_id: An ID of NSX-T Edge Gateway. Can be looked up using
           [NsxtEdgegateway](https://www.terraform.io/providers/vmware/vcd/latest/docs/data-sources/nsxt_edgegateway) data source
    :param str org: The name of organization to which the edge gateway belongs. Optional if defined at provider level.
    """
    __args__ = dict()
    __args__['edgeGatewayId'] = edge_gateway_id
    __args__['org'] = org
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('vcd:index/getNsxtEdgegatewayDhcpv6:getNsxtEdgegatewayDhcpv6', __args__, opts=opts, typ=GetNsxtEdgegatewayDhcpv6Result).value

    return AwaitableGetNsxtEdgegatewayDhcpv6Result(
        dns_servers=pulumi.get(__ret__, 'dns_servers'),
        domain_names=pulumi.get(__ret__, 'domain_names'),
        edge_gateway_id=pulumi.get(__ret__, 'edge_gateway_id'),
        id=pulumi.get(__ret__, 'id'),
        mode=pulumi.get(__ret__, 'mode'),
        org=pulumi.get(__ret__, 'org'))
def get_nsxt_edgegateway_dhcpv6_output(edge_gateway_id: Optional[pulumi.Input[str]] = None,
                                       org: Optional[pulumi.Input[Optional[str]]] = None,
                                       opts: Optional[Union[pulumi.InvokeOptions, pulumi.InvokeOutputOptions]] = None) -> pulumi.Output[GetNsxtEdgegatewayDhcpv6Result]:
    """
    Provides a data source to read DHCPv6 configuration for NSX-T Edge Gateways.

    ## Example Usage

    ```python
    import pulumi
    import pulumi_vcd as vcd

    testing_in_vdc = vcd.get_nsxt_edgegateway_dhcpv6(org="datacloud",
        edge_gateway_id=testing_in_vdc_vcd_nsxt_edgegateway["id"])
    ```


    :param str edge_gateway_id: An ID of NSX-T Edge Gateway. Can be looked up using
           [NsxtEdgegateway](https://www.terraform.io/providers/vmware/vcd/latest/docs/data-sources/nsxt_edgegateway) data source
    :param str org: The name of organization to which the edge gateway belongs. Optional if defined at provider level.
    """
    __args__ = dict()
    __args__['edgeGatewayId'] = edge_gateway_id
    __args__['org'] = org
    opts = pulumi.InvokeOutputOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke_output('vcd:index/getNsxtEdgegatewayDhcpv6:getNsxtEdgegatewayDhcpv6', __args__, opts=opts, typ=GetNsxtEdgegatewayDhcpv6Result)
    return __ret__.apply(lambda __response__: GetNsxtEdgegatewayDhcpv6Result(
        dns_servers=pulumi.get(__response__, 'dns_servers'),
        domain_names=pulumi.get(__response__, 'domain_names'),
        edge_gateway_id=pulumi.get(__response__, 'edge_gateway_id'),
        id=pulumi.get(__response__, 'id'),
        mode=pulumi.get(__response__, 'mode'),
        org=pulumi.get(__response__, 'org')))
