# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from . import _utilities

__all__ = [
    'GetOrgGroupResult',
    'AwaitableGetOrgGroupResult',
    'get_org_group',
    'get_org_group_output',
]

@pulumi.output_type
class GetOrgGroupResult:
    """
    A collection of values returned by getOrgGroup.
    """
    def __init__(__self__, description=None, id=None, name=None, org=None, provider_type=None, role=None, user_names=None):
        if description and not isinstance(description, str):
            raise TypeError("Expected argument 'description' to be a str")
        pulumi.set(__self__, "description", description)
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if name and not isinstance(name, str):
            raise TypeError("Expected argument 'name' to be a str")
        pulumi.set(__self__, "name", name)
        if org and not isinstance(org, str):
            raise TypeError("Expected argument 'org' to be a str")
        pulumi.set(__self__, "org", org)
        if provider_type and not isinstance(provider_type, str):
            raise TypeError("Expected argument 'provider_type' to be a str")
        pulumi.set(__self__, "provider_type", provider_type)
        if role and not isinstance(role, str):
            raise TypeError("Expected argument 'role' to be a str")
        pulumi.set(__self__, "role", role)
        if user_names and not isinstance(user_names, list):
            raise TypeError("Expected argument 'user_names' to be a list")
        pulumi.set(__self__, "user_names", user_names)

    @property
    @pulumi.getter
    def description(self) -> str:
        return pulumi.get(self, "description")

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        The provider-assigned unique ID for this managed resource.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter
    def name(self) -> str:
        return pulumi.get(self, "name")

    @property
    @pulumi.getter
    def org(self) -> Optional[str]:
        return pulumi.get(self, "org")

    @property
    @pulumi.getter(name="providerType")
    def provider_type(self) -> str:
        return pulumi.get(self, "provider_type")

    @property
    @pulumi.getter
    def role(self) -> str:
        return pulumi.get(self, "role")

    @property
    @pulumi.getter(name="userNames")
    def user_names(self) -> Sequence[str]:
        return pulumi.get(self, "user_names")


class AwaitableGetOrgGroupResult(GetOrgGroupResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetOrgGroupResult(
            description=self.description,
            id=self.id,
            name=self.name,
            org=self.org,
            provider_type=self.provider_type,
            role=self.role,
            user_names=self.user_names)


def get_org_group(name: Optional[str] = None,
                  org: Optional[str] = None,
                  opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetOrgGroupResult:
    """
    Provides a data source for VMware Cloud Director Organization Groups. This can be used to fetch organization groups already defined in `SAML`, `OAUTH` or `LDAP`.

    Supported in provider *v3.6+*

    ## Example Usage

    ### To Fetch An Organization Group

    ```python
    import pulumi
    import pulumi_vcd as vcd

    org1 = vcd.get_org_group(org="org1",
        name="Org1-AdminGroup")
    pulumi.export("groupRole", org1.role)
    ```


    :param str name: A unique name for the group.
    :param str org: The name of organization to which the VDC belongs. Optional if defined at provider level.
    """
    __args__ = dict()
    __args__['name'] = name
    __args__['org'] = org
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('vcd:index/getOrgGroup:getOrgGroup', __args__, opts=opts, typ=GetOrgGroupResult).value

    return AwaitableGetOrgGroupResult(
        description=pulumi.get(__ret__, 'description'),
        id=pulumi.get(__ret__, 'id'),
        name=pulumi.get(__ret__, 'name'),
        org=pulumi.get(__ret__, 'org'),
        provider_type=pulumi.get(__ret__, 'provider_type'),
        role=pulumi.get(__ret__, 'role'),
        user_names=pulumi.get(__ret__, 'user_names'))
def get_org_group_output(name: Optional[pulumi.Input[str]] = None,
                         org: Optional[pulumi.Input[Optional[str]]] = None,
                         opts: Optional[Union[pulumi.InvokeOptions, pulumi.InvokeOutputOptions]] = None) -> pulumi.Output[GetOrgGroupResult]:
    """
    Provides a data source for VMware Cloud Director Organization Groups. This can be used to fetch organization groups already defined in `SAML`, `OAUTH` or `LDAP`.

    Supported in provider *v3.6+*

    ## Example Usage

    ### To Fetch An Organization Group

    ```python
    import pulumi
    import pulumi_vcd as vcd

    org1 = vcd.get_org_group(org="org1",
        name="Org1-AdminGroup")
    pulumi.export("groupRole", org1.role)
    ```


    :param str name: A unique name for the group.
    :param str org: The name of organization to which the VDC belongs. Optional if defined at provider level.
    """
    __args__ = dict()
    __args__['name'] = name
    __args__['org'] = org
    opts = pulumi.InvokeOutputOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke_output('vcd:index/getOrgGroup:getOrgGroup', __args__, opts=opts, typ=GetOrgGroupResult)
    return __ret__.apply(lambda __response__: GetOrgGroupResult(
        description=pulumi.get(__response__, 'description'),
        id=pulumi.get(__response__, 'id'),
        name=pulumi.get(__response__, 'name'),
        org=pulumi.get(__response__, 'org'),
        provider_type=pulumi.get(__response__, 'provider_type'),
        role=pulumi.get(__response__, 'role'),
        user_names=pulumi.get(__response__, 'user_names')))
