# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from . import _utilities
from . import outputs
from ._inputs import *

__all__ = ['IpSpaceCustomQuotaArgs', 'IpSpaceCustomQuota']

@pulumi.input_type
class IpSpaceCustomQuotaArgs:
    def __init__(__self__, *,
                 ip_space_id: pulumi.Input[str],
                 org_id: pulumi.Input[str],
                 ip_prefix_quotas: Optional[pulumi.Input[Sequence[pulumi.Input['IpSpaceCustomQuotaIpPrefixQuotaArgs']]]] = None,
                 ip_range_quota: Optional[pulumi.Input[str]] = None):
        """
        The set of arguments for constructing a IpSpaceCustomQuota resource.
        :param pulumi.Input[str] ip_space_id: IP Space ID to set Custom Quotas
        :param pulumi.Input[str] org_id: Organization ID, for which the Quota should be customized
        :param pulumi.Input[Sequence[pulumi.Input['IpSpaceCustomQuotaIpPrefixQuotaArgs']]] ip_prefix_quotas: IP Prefix Quota set in ip_prefix_quota blocks.
               Will inherit the default Quota set in `IpSpace` if not set
               
               > The resource `IpSpaceCustomQuota` can only be created for an Org after an NSX-T Edge
               Gateway backed by Provider Gateway is created within the Org. An explicit `depends_on` constraint
               for an Edge Gateway to exist might be required. (See the example.)
               
               <a id="ip-prefix-quota"></a>
        :param pulumi.Input[str] ip_range_quota: Floating IP Quota. Will inherit the default Quota set in
               `IpSpace` if not set
        """
        pulumi.set(__self__, "ip_space_id", ip_space_id)
        pulumi.set(__self__, "org_id", org_id)
        if ip_prefix_quotas is not None:
            pulumi.set(__self__, "ip_prefix_quotas", ip_prefix_quotas)
        if ip_range_quota is not None:
            pulumi.set(__self__, "ip_range_quota", ip_range_quota)

    @property
    @pulumi.getter(name="ipSpaceId")
    def ip_space_id(self) -> pulumi.Input[str]:
        """
        IP Space ID to set Custom Quotas
        """
        return pulumi.get(self, "ip_space_id")

    @ip_space_id.setter
    def ip_space_id(self, value: pulumi.Input[str]):
        pulumi.set(self, "ip_space_id", value)

    @property
    @pulumi.getter(name="orgId")
    def org_id(self) -> pulumi.Input[str]:
        """
        Organization ID, for which the Quota should be customized
        """
        return pulumi.get(self, "org_id")

    @org_id.setter
    def org_id(self, value: pulumi.Input[str]):
        pulumi.set(self, "org_id", value)

    @property
    @pulumi.getter(name="ipPrefixQuotas")
    def ip_prefix_quotas(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['IpSpaceCustomQuotaIpPrefixQuotaArgs']]]]:
        """
        IP Prefix Quota set in ip_prefix_quota blocks.
        Will inherit the default Quota set in `IpSpace` if not set

        > The resource `IpSpaceCustomQuota` can only be created for an Org after an NSX-T Edge
        Gateway backed by Provider Gateway is created within the Org. An explicit `depends_on` constraint
        for an Edge Gateway to exist might be required. (See the example.)

        <a id="ip-prefix-quota"></a>
        """
        return pulumi.get(self, "ip_prefix_quotas")

    @ip_prefix_quotas.setter
    def ip_prefix_quotas(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['IpSpaceCustomQuotaIpPrefixQuotaArgs']]]]):
        pulumi.set(self, "ip_prefix_quotas", value)

    @property
    @pulumi.getter(name="ipRangeQuota")
    def ip_range_quota(self) -> Optional[pulumi.Input[str]]:
        """
        Floating IP Quota. Will inherit the default Quota set in
        `IpSpace` if not set
        """
        return pulumi.get(self, "ip_range_quota")

    @ip_range_quota.setter
    def ip_range_quota(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "ip_range_quota", value)


@pulumi.input_type
class _IpSpaceCustomQuotaState:
    def __init__(__self__, *,
                 ip_prefix_quotas: Optional[pulumi.Input[Sequence[pulumi.Input['IpSpaceCustomQuotaIpPrefixQuotaArgs']]]] = None,
                 ip_range_quota: Optional[pulumi.Input[str]] = None,
                 ip_space_id: Optional[pulumi.Input[str]] = None,
                 org_id: Optional[pulumi.Input[str]] = None):
        """
        Input properties used for looking up and filtering IpSpaceCustomQuota resources.
        :param pulumi.Input[Sequence[pulumi.Input['IpSpaceCustomQuotaIpPrefixQuotaArgs']]] ip_prefix_quotas: IP Prefix Quota set in ip_prefix_quota blocks.
               Will inherit the default Quota set in `IpSpace` if not set
               
               > The resource `IpSpaceCustomQuota` can only be created for an Org after an NSX-T Edge
               Gateway backed by Provider Gateway is created within the Org. An explicit `depends_on` constraint
               for an Edge Gateway to exist might be required. (See the example.)
               
               <a id="ip-prefix-quota"></a>
        :param pulumi.Input[str] ip_range_quota: Floating IP Quota. Will inherit the default Quota set in
               `IpSpace` if not set
        :param pulumi.Input[str] ip_space_id: IP Space ID to set Custom Quotas
        :param pulumi.Input[str] org_id: Organization ID, for which the Quota should be customized
        """
        if ip_prefix_quotas is not None:
            pulumi.set(__self__, "ip_prefix_quotas", ip_prefix_quotas)
        if ip_range_quota is not None:
            pulumi.set(__self__, "ip_range_quota", ip_range_quota)
        if ip_space_id is not None:
            pulumi.set(__self__, "ip_space_id", ip_space_id)
        if org_id is not None:
            pulumi.set(__self__, "org_id", org_id)

    @property
    @pulumi.getter(name="ipPrefixQuotas")
    def ip_prefix_quotas(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['IpSpaceCustomQuotaIpPrefixQuotaArgs']]]]:
        """
        IP Prefix Quota set in ip_prefix_quota blocks.
        Will inherit the default Quota set in `IpSpace` if not set

        > The resource `IpSpaceCustomQuota` can only be created for an Org after an NSX-T Edge
        Gateway backed by Provider Gateway is created within the Org. An explicit `depends_on` constraint
        for an Edge Gateway to exist might be required. (See the example.)

        <a id="ip-prefix-quota"></a>
        """
        return pulumi.get(self, "ip_prefix_quotas")

    @ip_prefix_quotas.setter
    def ip_prefix_quotas(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['IpSpaceCustomQuotaIpPrefixQuotaArgs']]]]):
        pulumi.set(self, "ip_prefix_quotas", value)

    @property
    @pulumi.getter(name="ipRangeQuota")
    def ip_range_quota(self) -> Optional[pulumi.Input[str]]:
        """
        Floating IP Quota. Will inherit the default Quota set in
        `IpSpace` if not set
        """
        return pulumi.get(self, "ip_range_quota")

    @ip_range_quota.setter
    def ip_range_quota(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "ip_range_quota", value)

    @property
    @pulumi.getter(name="ipSpaceId")
    def ip_space_id(self) -> Optional[pulumi.Input[str]]:
        """
        IP Space ID to set Custom Quotas
        """
        return pulumi.get(self, "ip_space_id")

    @ip_space_id.setter
    def ip_space_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "ip_space_id", value)

    @property
    @pulumi.getter(name="orgId")
    def org_id(self) -> Optional[pulumi.Input[str]]:
        """
        Organization ID, for which the Quota should be customized
        """
        return pulumi.get(self, "org_id")

    @org_id.setter
    def org_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "org_id", value)


class IpSpaceCustomQuota(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 ip_prefix_quotas: Optional[pulumi.Input[Sequence[pulumi.Input[Union['IpSpaceCustomQuotaIpPrefixQuotaArgs', 'IpSpaceCustomQuotaIpPrefixQuotaArgsDict']]]]] = None,
                 ip_range_quota: Optional[pulumi.Input[str]] = None,
                 ip_space_id: Optional[pulumi.Input[str]] = None,
                 org_id: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        """
        Create a IpSpaceCustomQuota resource with the given unique name, props, and options.
        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[Sequence[pulumi.Input[Union['IpSpaceCustomQuotaIpPrefixQuotaArgs', 'IpSpaceCustomQuotaIpPrefixQuotaArgsDict']]]] ip_prefix_quotas: IP Prefix Quota set in ip_prefix_quota blocks.
               Will inherit the default Quota set in `IpSpace` if not set
               
               > The resource `IpSpaceCustomQuota` can only be created for an Org after an NSX-T Edge
               Gateway backed by Provider Gateway is created within the Org. An explicit `depends_on` constraint
               for an Edge Gateway to exist might be required. (See the example.)
               
               <a id="ip-prefix-quota"></a>
        :param pulumi.Input[str] ip_range_quota: Floating IP Quota. Will inherit the default Quota set in
               `IpSpace` if not set
        :param pulumi.Input[str] ip_space_id: IP Space ID to set Custom Quotas
        :param pulumi.Input[str] org_id: Organization ID, for which the Quota should be customized
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: IpSpaceCustomQuotaArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        Create a IpSpaceCustomQuota resource with the given unique name, props, and options.
        :param str resource_name: The name of the resource.
        :param IpSpaceCustomQuotaArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(IpSpaceCustomQuotaArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 ip_prefix_quotas: Optional[pulumi.Input[Sequence[pulumi.Input[Union['IpSpaceCustomQuotaIpPrefixQuotaArgs', 'IpSpaceCustomQuotaIpPrefixQuotaArgsDict']]]]] = None,
                 ip_range_quota: Optional[pulumi.Input[str]] = None,
                 ip_space_id: Optional[pulumi.Input[str]] = None,
                 org_id: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = IpSpaceCustomQuotaArgs.__new__(IpSpaceCustomQuotaArgs)

            __props__.__dict__["ip_prefix_quotas"] = ip_prefix_quotas
            __props__.__dict__["ip_range_quota"] = ip_range_quota
            if ip_space_id is None and not opts.urn:
                raise TypeError("Missing required property 'ip_space_id'")
            __props__.__dict__["ip_space_id"] = ip_space_id
            if org_id is None and not opts.urn:
                raise TypeError("Missing required property 'org_id'")
            __props__.__dict__["org_id"] = org_id
        super(IpSpaceCustomQuota, __self__).__init__(
            'vcd:index/ipSpaceCustomQuota:IpSpaceCustomQuota',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            ip_prefix_quotas: Optional[pulumi.Input[Sequence[pulumi.Input[Union['IpSpaceCustomQuotaIpPrefixQuotaArgs', 'IpSpaceCustomQuotaIpPrefixQuotaArgsDict']]]]] = None,
            ip_range_quota: Optional[pulumi.Input[str]] = None,
            ip_space_id: Optional[pulumi.Input[str]] = None,
            org_id: Optional[pulumi.Input[str]] = None) -> 'IpSpaceCustomQuota':
        """
        Get an existing IpSpaceCustomQuota resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[Sequence[pulumi.Input[Union['IpSpaceCustomQuotaIpPrefixQuotaArgs', 'IpSpaceCustomQuotaIpPrefixQuotaArgsDict']]]] ip_prefix_quotas: IP Prefix Quota set in ip_prefix_quota blocks.
               Will inherit the default Quota set in `IpSpace` if not set
               
               > The resource `IpSpaceCustomQuota` can only be created for an Org after an NSX-T Edge
               Gateway backed by Provider Gateway is created within the Org. An explicit `depends_on` constraint
               for an Edge Gateway to exist might be required. (See the example.)
               
               <a id="ip-prefix-quota"></a>
        :param pulumi.Input[str] ip_range_quota: Floating IP Quota. Will inherit the default Quota set in
               `IpSpace` if not set
        :param pulumi.Input[str] ip_space_id: IP Space ID to set Custom Quotas
        :param pulumi.Input[str] org_id: Organization ID, for which the Quota should be customized
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = _IpSpaceCustomQuotaState.__new__(_IpSpaceCustomQuotaState)

        __props__.__dict__["ip_prefix_quotas"] = ip_prefix_quotas
        __props__.__dict__["ip_range_quota"] = ip_range_quota
        __props__.__dict__["ip_space_id"] = ip_space_id
        __props__.__dict__["org_id"] = org_id
        return IpSpaceCustomQuota(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter(name="ipPrefixQuotas")
    def ip_prefix_quotas(self) -> pulumi.Output[Optional[Sequence['outputs.IpSpaceCustomQuotaIpPrefixQuota']]]:
        """
        IP Prefix Quota set in ip_prefix_quota blocks.
        Will inherit the default Quota set in `IpSpace` if not set

        > The resource `IpSpaceCustomQuota` can only be created for an Org after an NSX-T Edge
        Gateway backed by Provider Gateway is created within the Org. An explicit `depends_on` constraint
        for an Edge Gateway to exist might be required. (See the example.)

        <a id="ip-prefix-quota"></a>
        """
        return pulumi.get(self, "ip_prefix_quotas")

    @property
    @pulumi.getter(name="ipRangeQuota")
    def ip_range_quota(self) -> pulumi.Output[Optional[str]]:
        """
        Floating IP Quota. Will inherit the default Quota set in
        `IpSpace` if not set
        """
        return pulumi.get(self, "ip_range_quota")

    @property
    @pulumi.getter(name="ipSpaceId")
    def ip_space_id(self) -> pulumi.Output[str]:
        """
        IP Space ID to set Custom Quotas
        """
        return pulumi.get(self, "ip_space_id")

    @property
    @pulumi.getter(name="orgId")
    def org_id(self) -> pulumi.Output[str]:
        """
        Organization ID, for which the Quota should be customized
        """
        return pulumi.get(self, "org_id")

