# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from . import _utilities
from . import outputs
from ._inputs import *

__all__ = ['NsxtDynamicSecurityGroupArgs', 'NsxtDynamicSecurityGroup']

@pulumi.input_type
class NsxtDynamicSecurityGroupArgs:
    def __init__(__self__, *,
                 vdc_group_id: pulumi.Input[str],
                 criterias: Optional[pulumi.Input[Sequence[pulumi.Input['NsxtDynamicSecurityGroupCriteriaArgs']]]] = None,
                 description: Optional[pulumi.Input[str]] = None,
                 name: Optional[pulumi.Input[str]] = None,
                 org: Optional[pulumi.Input[str]] = None):
        """
        The set of arguments for constructing a NsxtDynamicSecurityGroup resource.
        :param pulumi.Input[str] vdc_group_id: VDC Group ID for Dynamic Security Group creation.
        :param pulumi.Input[Sequence[pulumi.Input['NsxtDynamicSecurityGroupCriteriaArgs']]] criterias: Up to 3 criteria for matching VMs. List of criteria is matched with boolean
               `OR` operation and matching any of defined criteria will include objects. Each `criteria` can
               contains up to 4 `rule` definitions.
        :param pulumi.Input[str] description: An optional description of the Dynamic Security Group
        :param pulumi.Input[str] name: A unique name for Dynamic Security Group
        :param pulumi.Input[str] org: The name of organization to use, optional if defined at provider level. Useful
               when connected as sysadmin working across different organisations.
        """
        pulumi.set(__self__, "vdc_group_id", vdc_group_id)
        if criterias is not None:
            pulumi.set(__self__, "criterias", criterias)
        if description is not None:
            pulumi.set(__self__, "description", description)
        if name is not None:
            pulumi.set(__self__, "name", name)
        if org is not None:
            pulumi.set(__self__, "org", org)

    @property
    @pulumi.getter(name="vdcGroupId")
    def vdc_group_id(self) -> pulumi.Input[str]:
        """
        VDC Group ID for Dynamic Security Group creation.
        """
        return pulumi.get(self, "vdc_group_id")

    @vdc_group_id.setter
    def vdc_group_id(self, value: pulumi.Input[str]):
        pulumi.set(self, "vdc_group_id", value)

    @property
    @pulumi.getter
    def criterias(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['NsxtDynamicSecurityGroupCriteriaArgs']]]]:
        """
        Up to 3 criteria for matching VMs. List of criteria is matched with boolean
        `OR` operation and matching any of defined criteria will include objects. Each `criteria` can
        contains up to 4 `rule` definitions.
        """
        return pulumi.get(self, "criterias")

    @criterias.setter
    def criterias(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['NsxtDynamicSecurityGroupCriteriaArgs']]]]):
        pulumi.set(self, "criterias", value)

    @property
    @pulumi.getter
    def description(self) -> Optional[pulumi.Input[str]]:
        """
        An optional description of the Dynamic Security Group
        """
        return pulumi.get(self, "description")

    @description.setter
    def description(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "description", value)

    @property
    @pulumi.getter
    def name(self) -> Optional[pulumi.Input[str]]:
        """
        A unique name for Dynamic Security Group
        """
        return pulumi.get(self, "name")

    @name.setter
    def name(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "name", value)

    @property
    @pulumi.getter
    def org(self) -> Optional[pulumi.Input[str]]:
        """
        The name of organization to use, optional if defined at provider level. Useful
        when connected as sysadmin working across different organisations.
        """
        return pulumi.get(self, "org")

    @org.setter
    def org(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "org", value)


@pulumi.input_type
class _NsxtDynamicSecurityGroupState:
    def __init__(__self__, *,
                 criterias: Optional[pulumi.Input[Sequence[pulumi.Input['NsxtDynamicSecurityGroupCriteriaArgs']]]] = None,
                 description: Optional[pulumi.Input[str]] = None,
                 member_vms: Optional[pulumi.Input[Sequence[pulumi.Input['NsxtDynamicSecurityGroupMemberVmArgs']]]] = None,
                 name: Optional[pulumi.Input[str]] = None,
                 org: Optional[pulumi.Input[str]] = None,
                 vdc_group_id: Optional[pulumi.Input[str]] = None):
        """
        Input properties used for looking up and filtering NsxtDynamicSecurityGroup resources.
        :param pulumi.Input[Sequence[pulumi.Input['NsxtDynamicSecurityGroupCriteriaArgs']]] criterias: Up to 3 criteria for matching VMs. List of criteria is matched with boolean
               `OR` operation and matching any of defined criteria will include objects. Each `criteria` can
               contains up to 4 `rule` definitions.
        :param pulumi.Input[str] description: An optional description of the Dynamic Security Group
        :param pulumi.Input[Sequence[pulumi.Input['NsxtDynamicSecurityGroupMemberVmArgs']]] member_vms: A set of member VMs (if exist). see Member VMs below for details.
        :param pulumi.Input[str] name: A unique name for Dynamic Security Group
        :param pulumi.Input[str] org: The name of organization to use, optional if defined at provider level. Useful
               when connected as sysadmin working across different organisations.
        :param pulumi.Input[str] vdc_group_id: VDC Group ID for Dynamic Security Group creation.
        """
        if criterias is not None:
            pulumi.set(__self__, "criterias", criterias)
        if description is not None:
            pulumi.set(__self__, "description", description)
        if member_vms is not None:
            pulumi.set(__self__, "member_vms", member_vms)
        if name is not None:
            pulumi.set(__self__, "name", name)
        if org is not None:
            pulumi.set(__self__, "org", org)
        if vdc_group_id is not None:
            pulumi.set(__self__, "vdc_group_id", vdc_group_id)

    @property
    @pulumi.getter
    def criterias(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['NsxtDynamicSecurityGroupCriteriaArgs']]]]:
        """
        Up to 3 criteria for matching VMs. List of criteria is matched with boolean
        `OR` operation and matching any of defined criteria will include objects. Each `criteria` can
        contains up to 4 `rule` definitions.
        """
        return pulumi.get(self, "criterias")

    @criterias.setter
    def criterias(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['NsxtDynamicSecurityGroupCriteriaArgs']]]]):
        pulumi.set(self, "criterias", value)

    @property
    @pulumi.getter
    def description(self) -> Optional[pulumi.Input[str]]:
        """
        An optional description of the Dynamic Security Group
        """
        return pulumi.get(self, "description")

    @description.setter
    def description(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "description", value)

    @property
    @pulumi.getter(name="memberVms")
    def member_vms(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['NsxtDynamicSecurityGroupMemberVmArgs']]]]:
        """
        A set of member VMs (if exist). see Member VMs below for details.
        """
        return pulumi.get(self, "member_vms")

    @member_vms.setter
    def member_vms(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['NsxtDynamicSecurityGroupMemberVmArgs']]]]):
        pulumi.set(self, "member_vms", value)

    @property
    @pulumi.getter
    def name(self) -> Optional[pulumi.Input[str]]:
        """
        A unique name for Dynamic Security Group
        """
        return pulumi.get(self, "name")

    @name.setter
    def name(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "name", value)

    @property
    @pulumi.getter
    def org(self) -> Optional[pulumi.Input[str]]:
        """
        The name of organization to use, optional if defined at provider level. Useful
        when connected as sysadmin working across different organisations.
        """
        return pulumi.get(self, "org")

    @org.setter
    def org(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "org", value)

    @property
    @pulumi.getter(name="vdcGroupId")
    def vdc_group_id(self) -> Optional[pulumi.Input[str]]:
        """
        VDC Group ID for Dynamic Security Group creation.
        """
        return pulumi.get(self, "vdc_group_id")

    @vdc_group_id.setter
    def vdc_group_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "vdc_group_id", value)


class NsxtDynamicSecurityGroup(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 criterias: Optional[pulumi.Input[Sequence[pulumi.Input[Union['NsxtDynamicSecurityGroupCriteriaArgs', 'NsxtDynamicSecurityGroupCriteriaArgsDict']]]]] = None,
                 description: Optional[pulumi.Input[str]] = None,
                 name: Optional[pulumi.Input[str]] = None,
                 org: Optional[pulumi.Input[str]] = None,
                 vdc_group_id: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        """
        Create a NsxtDynamicSecurityGroup resource with the given unique name, props, and options.
        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[Sequence[pulumi.Input[Union['NsxtDynamicSecurityGroupCriteriaArgs', 'NsxtDynamicSecurityGroupCriteriaArgsDict']]]] criterias: Up to 3 criteria for matching VMs. List of criteria is matched with boolean
               `OR` operation and matching any of defined criteria will include objects. Each `criteria` can
               contains up to 4 `rule` definitions.
        :param pulumi.Input[str] description: An optional description of the Dynamic Security Group
        :param pulumi.Input[str] name: A unique name for Dynamic Security Group
        :param pulumi.Input[str] org: The name of organization to use, optional if defined at provider level. Useful
               when connected as sysadmin working across different organisations.
        :param pulumi.Input[str] vdc_group_id: VDC Group ID for Dynamic Security Group creation.
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: NsxtDynamicSecurityGroupArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        Create a NsxtDynamicSecurityGroup resource with the given unique name, props, and options.
        :param str resource_name: The name of the resource.
        :param NsxtDynamicSecurityGroupArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(NsxtDynamicSecurityGroupArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 criterias: Optional[pulumi.Input[Sequence[pulumi.Input[Union['NsxtDynamicSecurityGroupCriteriaArgs', 'NsxtDynamicSecurityGroupCriteriaArgsDict']]]]] = None,
                 description: Optional[pulumi.Input[str]] = None,
                 name: Optional[pulumi.Input[str]] = None,
                 org: Optional[pulumi.Input[str]] = None,
                 vdc_group_id: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = NsxtDynamicSecurityGroupArgs.__new__(NsxtDynamicSecurityGroupArgs)

            __props__.__dict__["criterias"] = criterias
            __props__.__dict__["description"] = description
            __props__.__dict__["name"] = name
            __props__.__dict__["org"] = org
            if vdc_group_id is None and not opts.urn:
                raise TypeError("Missing required property 'vdc_group_id'")
            __props__.__dict__["vdc_group_id"] = vdc_group_id
            __props__.__dict__["member_vms"] = None
        super(NsxtDynamicSecurityGroup, __self__).__init__(
            'vcd:index/nsxtDynamicSecurityGroup:NsxtDynamicSecurityGroup',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            criterias: Optional[pulumi.Input[Sequence[pulumi.Input[Union['NsxtDynamicSecurityGroupCriteriaArgs', 'NsxtDynamicSecurityGroupCriteriaArgsDict']]]]] = None,
            description: Optional[pulumi.Input[str]] = None,
            member_vms: Optional[pulumi.Input[Sequence[pulumi.Input[Union['NsxtDynamicSecurityGroupMemberVmArgs', 'NsxtDynamicSecurityGroupMemberVmArgsDict']]]]] = None,
            name: Optional[pulumi.Input[str]] = None,
            org: Optional[pulumi.Input[str]] = None,
            vdc_group_id: Optional[pulumi.Input[str]] = None) -> 'NsxtDynamicSecurityGroup':
        """
        Get an existing NsxtDynamicSecurityGroup resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[Sequence[pulumi.Input[Union['NsxtDynamicSecurityGroupCriteriaArgs', 'NsxtDynamicSecurityGroupCriteriaArgsDict']]]] criterias: Up to 3 criteria for matching VMs. List of criteria is matched with boolean
               `OR` operation and matching any of defined criteria will include objects. Each `criteria` can
               contains up to 4 `rule` definitions.
        :param pulumi.Input[str] description: An optional description of the Dynamic Security Group
        :param pulumi.Input[Sequence[pulumi.Input[Union['NsxtDynamicSecurityGroupMemberVmArgs', 'NsxtDynamicSecurityGroupMemberVmArgsDict']]]] member_vms: A set of member VMs (if exist). see Member VMs below for details.
        :param pulumi.Input[str] name: A unique name for Dynamic Security Group
        :param pulumi.Input[str] org: The name of organization to use, optional if defined at provider level. Useful
               when connected as sysadmin working across different organisations.
        :param pulumi.Input[str] vdc_group_id: VDC Group ID for Dynamic Security Group creation.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = _NsxtDynamicSecurityGroupState.__new__(_NsxtDynamicSecurityGroupState)

        __props__.__dict__["criterias"] = criterias
        __props__.__dict__["description"] = description
        __props__.__dict__["member_vms"] = member_vms
        __props__.__dict__["name"] = name
        __props__.__dict__["org"] = org
        __props__.__dict__["vdc_group_id"] = vdc_group_id
        return NsxtDynamicSecurityGroup(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter
    def criterias(self) -> pulumi.Output[Optional[Sequence['outputs.NsxtDynamicSecurityGroupCriteria']]]:
        """
        Up to 3 criteria for matching VMs. List of criteria is matched with boolean
        `OR` operation and matching any of defined criteria will include objects. Each `criteria` can
        contains up to 4 `rule` definitions.
        """
        return pulumi.get(self, "criterias")

    @property
    @pulumi.getter
    def description(self) -> pulumi.Output[Optional[str]]:
        """
        An optional description of the Dynamic Security Group
        """
        return pulumi.get(self, "description")

    @property
    @pulumi.getter(name="memberVms")
    def member_vms(self) -> pulumi.Output[Sequence['outputs.NsxtDynamicSecurityGroupMemberVm']]:
        """
        A set of member VMs (if exist). see Member VMs below for details.
        """
        return pulumi.get(self, "member_vms")

    @property
    @pulumi.getter
    def name(self) -> pulumi.Output[str]:
        """
        A unique name for Dynamic Security Group
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter
    def org(self) -> pulumi.Output[Optional[str]]:
        """
        The name of organization to use, optional if defined at provider level. Useful
        when connected as sysadmin working across different organisations.
        """
        return pulumi.get(self, "org")

    @property
    @pulumi.getter(name="vdcGroupId")
    def vdc_group_id(self) -> pulumi.Output[str]:
        """
        VDC Group ID for Dynamic Security Group creation.
        """
        return pulumi.get(self, "vdc_group_id")

