# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from . import _utilities

__all__ = ['NsxtEdgegatewayDhcpForwardingArgs', 'NsxtEdgegatewayDhcpForwarding']

@pulumi.input_type
class NsxtEdgegatewayDhcpForwardingArgs:
    def __init__(__self__, *,
                 dhcp_servers: pulumi.Input[Sequence[pulumi.Input[str]]],
                 edge_gateway_id: pulumi.Input[str],
                 enabled: pulumi.Input[bool],
                 org: Optional[pulumi.Input[str]] = None):
        """
        The set of arguments for constructing a NsxtEdgegatewayDhcpForwarding resource.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] dhcp_servers: IP addresses of DHCP servers. Maximum 8 can be specified.
               
               > Modification of the `dhcp_servers` field will not be changed in VCD when `enabled = false` because VCD API ignores DHCP server changes when DHCP forwarding is disabled.
        :param pulumi.Input[str] edge_gateway_id: NSX-T Edge Gateway ID.
        :param pulumi.Input[bool] enabled: DHCP Forwarding status.
        :param pulumi.Input[str] org: Org in which the NSX-T Edge Gateway is located, required
               if not set in the provider section.
        """
        pulumi.set(__self__, "dhcp_servers", dhcp_servers)
        pulumi.set(__self__, "edge_gateway_id", edge_gateway_id)
        pulumi.set(__self__, "enabled", enabled)
        if org is not None:
            pulumi.set(__self__, "org", org)

    @property
    @pulumi.getter(name="dhcpServers")
    def dhcp_servers(self) -> pulumi.Input[Sequence[pulumi.Input[str]]]:
        """
        IP addresses of DHCP servers. Maximum 8 can be specified.

        > Modification of the `dhcp_servers` field will not be changed in VCD when `enabled = false` because VCD API ignores DHCP server changes when DHCP forwarding is disabled.
        """
        return pulumi.get(self, "dhcp_servers")

    @dhcp_servers.setter
    def dhcp_servers(self, value: pulumi.Input[Sequence[pulumi.Input[str]]]):
        pulumi.set(self, "dhcp_servers", value)

    @property
    @pulumi.getter(name="edgeGatewayId")
    def edge_gateway_id(self) -> pulumi.Input[str]:
        """
        NSX-T Edge Gateway ID.
        """
        return pulumi.get(self, "edge_gateway_id")

    @edge_gateway_id.setter
    def edge_gateway_id(self, value: pulumi.Input[str]):
        pulumi.set(self, "edge_gateway_id", value)

    @property
    @pulumi.getter
    def enabled(self) -> pulumi.Input[bool]:
        """
        DHCP Forwarding status.
        """
        return pulumi.get(self, "enabled")

    @enabled.setter
    def enabled(self, value: pulumi.Input[bool]):
        pulumi.set(self, "enabled", value)

    @property
    @pulumi.getter
    def org(self) -> Optional[pulumi.Input[str]]:
        """
        Org in which the NSX-T Edge Gateway is located, required
        if not set in the provider section.
        """
        return pulumi.get(self, "org")

    @org.setter
    def org(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "org", value)


@pulumi.input_type
class _NsxtEdgegatewayDhcpForwardingState:
    def __init__(__self__, *,
                 dhcp_servers: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 edge_gateway_id: Optional[pulumi.Input[str]] = None,
                 enabled: Optional[pulumi.Input[bool]] = None,
                 org: Optional[pulumi.Input[str]] = None):
        """
        Input properties used for looking up and filtering NsxtEdgegatewayDhcpForwarding resources.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] dhcp_servers: IP addresses of DHCP servers. Maximum 8 can be specified.
               
               > Modification of the `dhcp_servers` field will not be changed in VCD when `enabled = false` because VCD API ignores DHCP server changes when DHCP forwarding is disabled.
        :param pulumi.Input[str] edge_gateway_id: NSX-T Edge Gateway ID.
        :param pulumi.Input[bool] enabled: DHCP Forwarding status.
        :param pulumi.Input[str] org: Org in which the NSX-T Edge Gateway is located, required
               if not set in the provider section.
        """
        if dhcp_servers is not None:
            pulumi.set(__self__, "dhcp_servers", dhcp_servers)
        if edge_gateway_id is not None:
            pulumi.set(__self__, "edge_gateway_id", edge_gateway_id)
        if enabled is not None:
            pulumi.set(__self__, "enabled", enabled)
        if org is not None:
            pulumi.set(__self__, "org", org)

    @property
    @pulumi.getter(name="dhcpServers")
    def dhcp_servers(self) -> Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]:
        """
        IP addresses of DHCP servers. Maximum 8 can be specified.

        > Modification of the `dhcp_servers` field will not be changed in VCD when `enabled = false` because VCD API ignores DHCP server changes when DHCP forwarding is disabled.
        """
        return pulumi.get(self, "dhcp_servers")

    @dhcp_servers.setter
    def dhcp_servers(self, value: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]):
        pulumi.set(self, "dhcp_servers", value)

    @property
    @pulumi.getter(name="edgeGatewayId")
    def edge_gateway_id(self) -> Optional[pulumi.Input[str]]:
        """
        NSX-T Edge Gateway ID.
        """
        return pulumi.get(self, "edge_gateway_id")

    @edge_gateway_id.setter
    def edge_gateway_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "edge_gateway_id", value)

    @property
    @pulumi.getter
    def enabled(self) -> Optional[pulumi.Input[bool]]:
        """
        DHCP Forwarding status.
        """
        return pulumi.get(self, "enabled")

    @enabled.setter
    def enabled(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "enabled", value)

    @property
    @pulumi.getter
    def org(self) -> Optional[pulumi.Input[str]]:
        """
        Org in which the NSX-T Edge Gateway is located, required
        if not set in the provider section.
        """
        return pulumi.get(self, "org")

    @org.setter
    def org(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "org", value)


class NsxtEdgegatewayDhcpForwarding(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 dhcp_servers: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 edge_gateway_id: Optional[pulumi.Input[str]] = None,
                 enabled: Optional[pulumi.Input[bool]] = None,
                 org: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        """
        Create a NsxtEdgegatewayDhcpForwarding resource with the given unique name, props, and options.
        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] dhcp_servers: IP addresses of DHCP servers. Maximum 8 can be specified.
               
               > Modification of the `dhcp_servers` field will not be changed in VCD when `enabled = false` because VCD API ignores DHCP server changes when DHCP forwarding is disabled.
        :param pulumi.Input[str] edge_gateway_id: NSX-T Edge Gateway ID.
        :param pulumi.Input[bool] enabled: DHCP Forwarding status.
        :param pulumi.Input[str] org: Org in which the NSX-T Edge Gateway is located, required
               if not set in the provider section.
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: NsxtEdgegatewayDhcpForwardingArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        Create a NsxtEdgegatewayDhcpForwarding resource with the given unique name, props, and options.
        :param str resource_name: The name of the resource.
        :param NsxtEdgegatewayDhcpForwardingArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(NsxtEdgegatewayDhcpForwardingArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 dhcp_servers: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 edge_gateway_id: Optional[pulumi.Input[str]] = None,
                 enabled: Optional[pulumi.Input[bool]] = None,
                 org: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = NsxtEdgegatewayDhcpForwardingArgs.__new__(NsxtEdgegatewayDhcpForwardingArgs)

            if dhcp_servers is None and not opts.urn:
                raise TypeError("Missing required property 'dhcp_servers'")
            __props__.__dict__["dhcp_servers"] = dhcp_servers
            if edge_gateway_id is None and not opts.urn:
                raise TypeError("Missing required property 'edge_gateway_id'")
            __props__.__dict__["edge_gateway_id"] = edge_gateway_id
            if enabled is None and not opts.urn:
                raise TypeError("Missing required property 'enabled'")
            __props__.__dict__["enabled"] = enabled
            __props__.__dict__["org"] = org
        super(NsxtEdgegatewayDhcpForwarding, __self__).__init__(
            'vcd:index/nsxtEdgegatewayDhcpForwarding:NsxtEdgegatewayDhcpForwarding',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            dhcp_servers: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
            edge_gateway_id: Optional[pulumi.Input[str]] = None,
            enabled: Optional[pulumi.Input[bool]] = None,
            org: Optional[pulumi.Input[str]] = None) -> 'NsxtEdgegatewayDhcpForwarding':
        """
        Get an existing NsxtEdgegatewayDhcpForwarding resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] dhcp_servers: IP addresses of DHCP servers. Maximum 8 can be specified.
               
               > Modification of the `dhcp_servers` field will not be changed in VCD when `enabled = false` because VCD API ignores DHCP server changes when DHCP forwarding is disabled.
        :param pulumi.Input[str] edge_gateway_id: NSX-T Edge Gateway ID.
        :param pulumi.Input[bool] enabled: DHCP Forwarding status.
        :param pulumi.Input[str] org: Org in which the NSX-T Edge Gateway is located, required
               if not set in the provider section.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = _NsxtEdgegatewayDhcpForwardingState.__new__(_NsxtEdgegatewayDhcpForwardingState)

        __props__.__dict__["dhcp_servers"] = dhcp_servers
        __props__.__dict__["edge_gateway_id"] = edge_gateway_id
        __props__.__dict__["enabled"] = enabled
        __props__.__dict__["org"] = org
        return NsxtEdgegatewayDhcpForwarding(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter(name="dhcpServers")
    def dhcp_servers(self) -> pulumi.Output[Sequence[str]]:
        """
        IP addresses of DHCP servers. Maximum 8 can be specified.

        > Modification of the `dhcp_servers` field will not be changed in VCD when `enabled = false` because VCD API ignores DHCP server changes when DHCP forwarding is disabled.
        """
        return pulumi.get(self, "dhcp_servers")

    @property
    @pulumi.getter(name="edgeGatewayId")
    def edge_gateway_id(self) -> pulumi.Output[str]:
        """
        NSX-T Edge Gateway ID.
        """
        return pulumi.get(self, "edge_gateway_id")

    @property
    @pulumi.getter
    def enabled(self) -> pulumi.Output[bool]:
        """
        DHCP Forwarding status.
        """
        return pulumi.get(self, "enabled")

    @property
    @pulumi.getter
    def org(self) -> pulumi.Output[Optional[str]]:
        """
        Org in which the NSX-T Edge Gateway is located, required
        if not set in the provider section.
        """
        return pulumi.get(self, "org")

