# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from . import _utilities

__all__ = ['NsxtEdgegatewayRateLimitingArgs', 'NsxtEdgegatewayRateLimiting']

@pulumi.input_type
class NsxtEdgegatewayRateLimitingArgs:
    def __init__(__self__, *,
                 edge_gateway_id: pulumi.Input[str],
                 egress_profile_id: Optional[pulumi.Input[str]] = None,
                 ingress_profile_id: Optional[pulumi.Input[str]] = None,
                 org: Optional[pulumi.Input[str]] = None):
        """
        The set of arguments for constructing a NsxtEdgegatewayRateLimiting resource.
        :param pulumi.Input[str] edge_gateway_id: NSX-T Edge Gateway ID
        :param pulumi.Input[str] egress_profile_id: A QoS profile to apply for egress traffic. *Note* leaving empty
               means `unlimited`.
               
               > Ingress and Egress profile IDs can be looked up using
               [`get_nsxt_edgegateway_qos_profile`](https://www.terraform.io/providers/vmware/vcd/latest/docs/resources/nsxt_edgegateway_qos_profile)
               data source.
        :param pulumi.Input[str] ingress_profile_id: A QoS profile to apply for ingress traffic. *Note* leaving empty
               means `unlimited`.
        :param pulumi.Input[str] org: Org in which the NSX-T Edge Gateway is located
        """
        pulumi.set(__self__, "edge_gateway_id", edge_gateway_id)
        if egress_profile_id is not None:
            pulumi.set(__self__, "egress_profile_id", egress_profile_id)
        if ingress_profile_id is not None:
            pulumi.set(__self__, "ingress_profile_id", ingress_profile_id)
        if org is not None:
            pulumi.set(__self__, "org", org)

    @property
    @pulumi.getter(name="edgeGatewayId")
    def edge_gateway_id(self) -> pulumi.Input[str]:
        """
        NSX-T Edge Gateway ID
        """
        return pulumi.get(self, "edge_gateway_id")

    @edge_gateway_id.setter
    def edge_gateway_id(self, value: pulumi.Input[str]):
        pulumi.set(self, "edge_gateway_id", value)

    @property
    @pulumi.getter(name="egressProfileId")
    def egress_profile_id(self) -> Optional[pulumi.Input[str]]:
        """
        A QoS profile to apply for egress traffic. *Note* leaving empty
        means `unlimited`.

        > Ingress and Egress profile IDs can be looked up using
        [`get_nsxt_edgegateway_qos_profile`](https://www.terraform.io/providers/vmware/vcd/latest/docs/resources/nsxt_edgegateway_qos_profile)
        data source.
        """
        return pulumi.get(self, "egress_profile_id")

    @egress_profile_id.setter
    def egress_profile_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "egress_profile_id", value)

    @property
    @pulumi.getter(name="ingressProfileId")
    def ingress_profile_id(self) -> Optional[pulumi.Input[str]]:
        """
        A QoS profile to apply for ingress traffic. *Note* leaving empty
        means `unlimited`.
        """
        return pulumi.get(self, "ingress_profile_id")

    @ingress_profile_id.setter
    def ingress_profile_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "ingress_profile_id", value)

    @property
    @pulumi.getter
    def org(self) -> Optional[pulumi.Input[str]]:
        """
        Org in which the NSX-T Edge Gateway is located
        """
        return pulumi.get(self, "org")

    @org.setter
    def org(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "org", value)


@pulumi.input_type
class _NsxtEdgegatewayRateLimitingState:
    def __init__(__self__, *,
                 edge_gateway_id: Optional[pulumi.Input[str]] = None,
                 egress_profile_id: Optional[pulumi.Input[str]] = None,
                 ingress_profile_id: Optional[pulumi.Input[str]] = None,
                 org: Optional[pulumi.Input[str]] = None):
        """
        Input properties used for looking up and filtering NsxtEdgegatewayRateLimiting resources.
        :param pulumi.Input[str] edge_gateway_id: NSX-T Edge Gateway ID
        :param pulumi.Input[str] egress_profile_id: A QoS profile to apply for egress traffic. *Note* leaving empty
               means `unlimited`.
               
               > Ingress and Egress profile IDs can be looked up using
               [`get_nsxt_edgegateway_qos_profile`](https://www.terraform.io/providers/vmware/vcd/latest/docs/resources/nsxt_edgegateway_qos_profile)
               data source.
        :param pulumi.Input[str] ingress_profile_id: A QoS profile to apply for ingress traffic. *Note* leaving empty
               means `unlimited`.
        :param pulumi.Input[str] org: Org in which the NSX-T Edge Gateway is located
        """
        if edge_gateway_id is not None:
            pulumi.set(__self__, "edge_gateway_id", edge_gateway_id)
        if egress_profile_id is not None:
            pulumi.set(__self__, "egress_profile_id", egress_profile_id)
        if ingress_profile_id is not None:
            pulumi.set(__self__, "ingress_profile_id", ingress_profile_id)
        if org is not None:
            pulumi.set(__self__, "org", org)

    @property
    @pulumi.getter(name="edgeGatewayId")
    def edge_gateway_id(self) -> Optional[pulumi.Input[str]]:
        """
        NSX-T Edge Gateway ID
        """
        return pulumi.get(self, "edge_gateway_id")

    @edge_gateway_id.setter
    def edge_gateway_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "edge_gateway_id", value)

    @property
    @pulumi.getter(name="egressProfileId")
    def egress_profile_id(self) -> Optional[pulumi.Input[str]]:
        """
        A QoS profile to apply for egress traffic. *Note* leaving empty
        means `unlimited`.

        > Ingress and Egress profile IDs can be looked up using
        [`get_nsxt_edgegateway_qos_profile`](https://www.terraform.io/providers/vmware/vcd/latest/docs/resources/nsxt_edgegateway_qos_profile)
        data source.
        """
        return pulumi.get(self, "egress_profile_id")

    @egress_profile_id.setter
    def egress_profile_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "egress_profile_id", value)

    @property
    @pulumi.getter(name="ingressProfileId")
    def ingress_profile_id(self) -> Optional[pulumi.Input[str]]:
        """
        A QoS profile to apply for ingress traffic. *Note* leaving empty
        means `unlimited`.
        """
        return pulumi.get(self, "ingress_profile_id")

    @ingress_profile_id.setter
    def ingress_profile_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "ingress_profile_id", value)

    @property
    @pulumi.getter
    def org(self) -> Optional[pulumi.Input[str]]:
        """
        Org in which the NSX-T Edge Gateway is located
        """
        return pulumi.get(self, "org")

    @org.setter
    def org(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "org", value)


class NsxtEdgegatewayRateLimiting(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 edge_gateway_id: Optional[pulumi.Input[str]] = None,
                 egress_profile_id: Optional[pulumi.Input[str]] = None,
                 ingress_profile_id: Optional[pulumi.Input[str]] = None,
                 org: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        """
        Create a NsxtEdgegatewayRateLimiting resource with the given unique name, props, and options.
        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] edge_gateway_id: NSX-T Edge Gateway ID
        :param pulumi.Input[str] egress_profile_id: A QoS profile to apply for egress traffic. *Note* leaving empty
               means `unlimited`.
               
               > Ingress and Egress profile IDs can be looked up using
               [`get_nsxt_edgegateway_qos_profile`](https://www.terraform.io/providers/vmware/vcd/latest/docs/resources/nsxt_edgegateway_qos_profile)
               data source.
        :param pulumi.Input[str] ingress_profile_id: A QoS profile to apply for ingress traffic. *Note* leaving empty
               means `unlimited`.
        :param pulumi.Input[str] org: Org in which the NSX-T Edge Gateway is located
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: NsxtEdgegatewayRateLimitingArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        Create a NsxtEdgegatewayRateLimiting resource with the given unique name, props, and options.
        :param str resource_name: The name of the resource.
        :param NsxtEdgegatewayRateLimitingArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(NsxtEdgegatewayRateLimitingArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 edge_gateway_id: Optional[pulumi.Input[str]] = None,
                 egress_profile_id: Optional[pulumi.Input[str]] = None,
                 ingress_profile_id: Optional[pulumi.Input[str]] = None,
                 org: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = NsxtEdgegatewayRateLimitingArgs.__new__(NsxtEdgegatewayRateLimitingArgs)

            if edge_gateway_id is None and not opts.urn:
                raise TypeError("Missing required property 'edge_gateway_id'")
            __props__.__dict__["edge_gateway_id"] = edge_gateway_id
            __props__.__dict__["egress_profile_id"] = egress_profile_id
            __props__.__dict__["ingress_profile_id"] = ingress_profile_id
            __props__.__dict__["org"] = org
        super(NsxtEdgegatewayRateLimiting, __self__).__init__(
            'vcd:index/nsxtEdgegatewayRateLimiting:NsxtEdgegatewayRateLimiting',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            edge_gateway_id: Optional[pulumi.Input[str]] = None,
            egress_profile_id: Optional[pulumi.Input[str]] = None,
            ingress_profile_id: Optional[pulumi.Input[str]] = None,
            org: Optional[pulumi.Input[str]] = None) -> 'NsxtEdgegatewayRateLimiting':
        """
        Get an existing NsxtEdgegatewayRateLimiting resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] edge_gateway_id: NSX-T Edge Gateway ID
        :param pulumi.Input[str] egress_profile_id: A QoS profile to apply for egress traffic. *Note* leaving empty
               means `unlimited`.
               
               > Ingress and Egress profile IDs can be looked up using
               [`get_nsxt_edgegateway_qos_profile`](https://www.terraform.io/providers/vmware/vcd/latest/docs/resources/nsxt_edgegateway_qos_profile)
               data source.
        :param pulumi.Input[str] ingress_profile_id: A QoS profile to apply for ingress traffic. *Note* leaving empty
               means `unlimited`.
        :param pulumi.Input[str] org: Org in which the NSX-T Edge Gateway is located
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = _NsxtEdgegatewayRateLimitingState.__new__(_NsxtEdgegatewayRateLimitingState)

        __props__.__dict__["edge_gateway_id"] = edge_gateway_id
        __props__.__dict__["egress_profile_id"] = egress_profile_id
        __props__.__dict__["ingress_profile_id"] = ingress_profile_id
        __props__.__dict__["org"] = org
        return NsxtEdgegatewayRateLimiting(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter(name="edgeGatewayId")
    def edge_gateway_id(self) -> pulumi.Output[str]:
        """
        NSX-T Edge Gateway ID
        """
        return pulumi.get(self, "edge_gateway_id")

    @property
    @pulumi.getter(name="egressProfileId")
    def egress_profile_id(self) -> pulumi.Output[Optional[str]]:
        """
        A QoS profile to apply for egress traffic. *Note* leaving empty
        means `unlimited`.

        > Ingress and Egress profile IDs can be looked up using
        [`get_nsxt_edgegateway_qos_profile`](https://www.terraform.io/providers/vmware/vcd/latest/docs/resources/nsxt_edgegateway_qos_profile)
        data source.
        """
        return pulumi.get(self, "egress_profile_id")

    @property
    @pulumi.getter(name="ingressProfileId")
    def ingress_profile_id(self) -> pulumi.Output[Optional[str]]:
        """
        A QoS profile to apply for ingress traffic. *Note* leaving empty
        means `unlimited`.
        """
        return pulumi.get(self, "ingress_profile_id")

    @property
    @pulumi.getter
    def org(self) -> pulumi.Output[Optional[str]]:
        """
        Org in which the NSX-T Edge Gateway is located
        """
        return pulumi.get(self, "org")

