# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from . import _utilities

__all__ = ['NsxtNetworkSegmentProfileArgs', 'NsxtNetworkSegmentProfile']

@pulumi.input_type
class NsxtNetworkSegmentProfileArgs:
    def __init__(__self__, *,
                 org_network_id: pulumi.Input[str],
                 ip_discovery_profile_id: Optional[pulumi.Input[str]] = None,
                 mac_discovery_profile_id: Optional[pulumi.Input[str]] = None,
                 org: Optional[pulumi.Input[str]] = None,
                 qos_profile_id: Optional[pulumi.Input[str]] = None,
                 segment_profile_template_id: Optional[pulumi.Input[str]] = None,
                 segment_security_profile_id: Optional[pulumi.Input[str]] = None,
                 spoof_guard_profile_id: Optional[pulumi.Input[str]] = None):
        """
        The set of arguments for constructing a NsxtNetworkSegmentProfile resource.
        :param pulumi.Input[str] org_network_id: Org VDC Network ID
        :param pulumi.Input[str] ip_discovery_profile_id: IP Discovery Profile ID. Can be referenced using
               [`get_nsxt_segment_ip_discovery_profile`](https://www.terraform.io/providers/vmware/vcd/latest/docs/data-sources/nsxt_segment_ip_discovery_profile)
               data source.
        :param pulumi.Input[str] mac_discovery_profile_id: MAC Discovery Profile ID. Can be referenced using
               [`get_nsxt_segment_mac_discovery_profile`](https://www.terraform.io/providers/vmware/vcd/latest/docs/data-sources/nsxt_segment_mac_discovery_profile)
               data source.
        :param pulumi.Input[str] org: The name of organization to use, optional if defined at provider level
        :param pulumi.Input[str] qos_profile_id: QoS Profile ID. Can be referenced using
               [`get_nsxt_segment_qos_profile`](https://www.terraform.io/providers/vmware/vcd/latest/docs/data-sources/nsxt_segment_qos_profile)
               data source.
        :param pulumi.Input[str] segment_profile_template_id: Segment Profile Template ID to be applied for this Org
               VDC Network
        :param pulumi.Input[str] segment_security_profile_id: Segment Security Profile ID. Can be referenced using
               [`get_nsxt_segment_security_profile`](https://www.terraform.io/providers/vmware/vcd/latest/docs/data-sources/nsxt_segment_security_profile)
               data source.
        :param pulumi.Input[str] spoof_guard_profile_id: Spoof Guard Profile ID. Can be referenced using
               [`get_nsxt_segment_spoof_guard_profile`](https://www.terraform.io/providers/vmware/vcd/latest/docs/data-sources/nsxt_segment_spoof_guard_profile)
               data source.
        """
        pulumi.set(__self__, "org_network_id", org_network_id)
        if ip_discovery_profile_id is not None:
            pulumi.set(__self__, "ip_discovery_profile_id", ip_discovery_profile_id)
        if mac_discovery_profile_id is not None:
            pulumi.set(__self__, "mac_discovery_profile_id", mac_discovery_profile_id)
        if org is not None:
            pulumi.set(__self__, "org", org)
        if qos_profile_id is not None:
            pulumi.set(__self__, "qos_profile_id", qos_profile_id)
        if segment_profile_template_id is not None:
            pulumi.set(__self__, "segment_profile_template_id", segment_profile_template_id)
        if segment_security_profile_id is not None:
            pulumi.set(__self__, "segment_security_profile_id", segment_security_profile_id)
        if spoof_guard_profile_id is not None:
            pulumi.set(__self__, "spoof_guard_profile_id", spoof_guard_profile_id)

    @property
    @pulumi.getter(name="orgNetworkId")
    def org_network_id(self) -> pulumi.Input[str]:
        """
        Org VDC Network ID
        """
        return pulumi.get(self, "org_network_id")

    @org_network_id.setter
    def org_network_id(self, value: pulumi.Input[str]):
        pulumi.set(self, "org_network_id", value)

    @property
    @pulumi.getter(name="ipDiscoveryProfileId")
    def ip_discovery_profile_id(self) -> Optional[pulumi.Input[str]]:
        """
        IP Discovery Profile ID. Can be referenced using
        [`get_nsxt_segment_ip_discovery_profile`](https://www.terraform.io/providers/vmware/vcd/latest/docs/data-sources/nsxt_segment_ip_discovery_profile)
        data source.
        """
        return pulumi.get(self, "ip_discovery_profile_id")

    @ip_discovery_profile_id.setter
    def ip_discovery_profile_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "ip_discovery_profile_id", value)

    @property
    @pulumi.getter(name="macDiscoveryProfileId")
    def mac_discovery_profile_id(self) -> Optional[pulumi.Input[str]]:
        """
        MAC Discovery Profile ID. Can be referenced using
        [`get_nsxt_segment_mac_discovery_profile`](https://www.terraform.io/providers/vmware/vcd/latest/docs/data-sources/nsxt_segment_mac_discovery_profile)
        data source.
        """
        return pulumi.get(self, "mac_discovery_profile_id")

    @mac_discovery_profile_id.setter
    def mac_discovery_profile_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "mac_discovery_profile_id", value)

    @property
    @pulumi.getter
    def org(self) -> Optional[pulumi.Input[str]]:
        """
        The name of organization to use, optional if defined at provider level
        """
        return pulumi.get(self, "org")

    @org.setter
    def org(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "org", value)

    @property
    @pulumi.getter(name="qosProfileId")
    def qos_profile_id(self) -> Optional[pulumi.Input[str]]:
        """
        QoS Profile ID. Can be referenced using
        [`get_nsxt_segment_qos_profile`](https://www.terraform.io/providers/vmware/vcd/latest/docs/data-sources/nsxt_segment_qos_profile)
        data source.
        """
        return pulumi.get(self, "qos_profile_id")

    @qos_profile_id.setter
    def qos_profile_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "qos_profile_id", value)

    @property
    @pulumi.getter(name="segmentProfileTemplateId")
    def segment_profile_template_id(self) -> Optional[pulumi.Input[str]]:
        """
        Segment Profile Template ID to be applied for this Org
        VDC Network
        """
        return pulumi.get(self, "segment_profile_template_id")

    @segment_profile_template_id.setter
    def segment_profile_template_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "segment_profile_template_id", value)

    @property
    @pulumi.getter(name="segmentSecurityProfileId")
    def segment_security_profile_id(self) -> Optional[pulumi.Input[str]]:
        """
        Segment Security Profile ID. Can be referenced using
        [`get_nsxt_segment_security_profile`](https://www.terraform.io/providers/vmware/vcd/latest/docs/data-sources/nsxt_segment_security_profile)
        data source.
        """
        return pulumi.get(self, "segment_security_profile_id")

    @segment_security_profile_id.setter
    def segment_security_profile_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "segment_security_profile_id", value)

    @property
    @pulumi.getter(name="spoofGuardProfileId")
    def spoof_guard_profile_id(self) -> Optional[pulumi.Input[str]]:
        """
        Spoof Guard Profile ID. Can be referenced using
        [`get_nsxt_segment_spoof_guard_profile`](https://www.terraform.io/providers/vmware/vcd/latest/docs/data-sources/nsxt_segment_spoof_guard_profile)
        data source.
        """
        return pulumi.get(self, "spoof_guard_profile_id")

    @spoof_guard_profile_id.setter
    def spoof_guard_profile_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "spoof_guard_profile_id", value)


@pulumi.input_type
class _NsxtNetworkSegmentProfileState:
    def __init__(__self__, *,
                 ip_discovery_profile_id: Optional[pulumi.Input[str]] = None,
                 mac_discovery_profile_id: Optional[pulumi.Input[str]] = None,
                 org: Optional[pulumi.Input[str]] = None,
                 org_network_id: Optional[pulumi.Input[str]] = None,
                 qos_profile_id: Optional[pulumi.Input[str]] = None,
                 segment_profile_template_id: Optional[pulumi.Input[str]] = None,
                 segment_profile_template_name: Optional[pulumi.Input[str]] = None,
                 segment_security_profile_id: Optional[pulumi.Input[str]] = None,
                 spoof_guard_profile_id: Optional[pulumi.Input[str]] = None):
        """
        Input properties used for looking up and filtering NsxtNetworkSegmentProfile resources.
        :param pulumi.Input[str] ip_discovery_profile_id: IP Discovery Profile ID. Can be referenced using
               [`get_nsxt_segment_ip_discovery_profile`](https://www.terraform.io/providers/vmware/vcd/latest/docs/data-sources/nsxt_segment_ip_discovery_profile)
               data source.
        :param pulumi.Input[str] mac_discovery_profile_id: MAC Discovery Profile ID. Can be referenced using
               [`get_nsxt_segment_mac_discovery_profile`](https://www.terraform.io/providers/vmware/vcd/latest/docs/data-sources/nsxt_segment_mac_discovery_profile)
               data source.
        :param pulumi.Input[str] org: The name of organization to use, optional if defined at provider level
        :param pulumi.Input[str] org_network_id: Org VDC Network ID
        :param pulumi.Input[str] qos_profile_id: QoS Profile ID. Can be referenced using
               [`get_nsxt_segment_qos_profile`](https://www.terraform.io/providers/vmware/vcd/latest/docs/data-sources/nsxt_segment_qos_profile)
               data source.
        :param pulumi.Input[str] segment_profile_template_id: Segment Profile Template ID to be applied for this Org
               VDC Network
        :param pulumi.Input[str] segment_profile_template_name: Segment Profile Template Name
        :param pulumi.Input[str] segment_security_profile_id: Segment Security Profile ID. Can be referenced using
               [`get_nsxt_segment_security_profile`](https://www.terraform.io/providers/vmware/vcd/latest/docs/data-sources/nsxt_segment_security_profile)
               data source.
        :param pulumi.Input[str] spoof_guard_profile_id: Spoof Guard Profile ID. Can be referenced using
               [`get_nsxt_segment_spoof_guard_profile`](https://www.terraform.io/providers/vmware/vcd/latest/docs/data-sources/nsxt_segment_spoof_guard_profile)
               data source.
        """
        if ip_discovery_profile_id is not None:
            pulumi.set(__self__, "ip_discovery_profile_id", ip_discovery_profile_id)
        if mac_discovery_profile_id is not None:
            pulumi.set(__self__, "mac_discovery_profile_id", mac_discovery_profile_id)
        if org is not None:
            pulumi.set(__self__, "org", org)
        if org_network_id is not None:
            pulumi.set(__self__, "org_network_id", org_network_id)
        if qos_profile_id is not None:
            pulumi.set(__self__, "qos_profile_id", qos_profile_id)
        if segment_profile_template_id is not None:
            pulumi.set(__self__, "segment_profile_template_id", segment_profile_template_id)
        if segment_profile_template_name is not None:
            pulumi.set(__self__, "segment_profile_template_name", segment_profile_template_name)
        if segment_security_profile_id is not None:
            pulumi.set(__self__, "segment_security_profile_id", segment_security_profile_id)
        if spoof_guard_profile_id is not None:
            pulumi.set(__self__, "spoof_guard_profile_id", spoof_guard_profile_id)

    @property
    @pulumi.getter(name="ipDiscoveryProfileId")
    def ip_discovery_profile_id(self) -> Optional[pulumi.Input[str]]:
        """
        IP Discovery Profile ID. Can be referenced using
        [`get_nsxt_segment_ip_discovery_profile`](https://www.terraform.io/providers/vmware/vcd/latest/docs/data-sources/nsxt_segment_ip_discovery_profile)
        data source.
        """
        return pulumi.get(self, "ip_discovery_profile_id")

    @ip_discovery_profile_id.setter
    def ip_discovery_profile_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "ip_discovery_profile_id", value)

    @property
    @pulumi.getter(name="macDiscoveryProfileId")
    def mac_discovery_profile_id(self) -> Optional[pulumi.Input[str]]:
        """
        MAC Discovery Profile ID. Can be referenced using
        [`get_nsxt_segment_mac_discovery_profile`](https://www.terraform.io/providers/vmware/vcd/latest/docs/data-sources/nsxt_segment_mac_discovery_profile)
        data source.
        """
        return pulumi.get(self, "mac_discovery_profile_id")

    @mac_discovery_profile_id.setter
    def mac_discovery_profile_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "mac_discovery_profile_id", value)

    @property
    @pulumi.getter
    def org(self) -> Optional[pulumi.Input[str]]:
        """
        The name of organization to use, optional if defined at provider level
        """
        return pulumi.get(self, "org")

    @org.setter
    def org(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "org", value)

    @property
    @pulumi.getter(name="orgNetworkId")
    def org_network_id(self) -> Optional[pulumi.Input[str]]:
        """
        Org VDC Network ID
        """
        return pulumi.get(self, "org_network_id")

    @org_network_id.setter
    def org_network_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "org_network_id", value)

    @property
    @pulumi.getter(name="qosProfileId")
    def qos_profile_id(self) -> Optional[pulumi.Input[str]]:
        """
        QoS Profile ID. Can be referenced using
        [`get_nsxt_segment_qos_profile`](https://www.terraform.io/providers/vmware/vcd/latest/docs/data-sources/nsxt_segment_qos_profile)
        data source.
        """
        return pulumi.get(self, "qos_profile_id")

    @qos_profile_id.setter
    def qos_profile_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "qos_profile_id", value)

    @property
    @pulumi.getter(name="segmentProfileTemplateId")
    def segment_profile_template_id(self) -> Optional[pulumi.Input[str]]:
        """
        Segment Profile Template ID to be applied for this Org
        VDC Network
        """
        return pulumi.get(self, "segment_profile_template_id")

    @segment_profile_template_id.setter
    def segment_profile_template_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "segment_profile_template_id", value)

    @property
    @pulumi.getter(name="segmentProfileTemplateName")
    def segment_profile_template_name(self) -> Optional[pulumi.Input[str]]:
        """
        Segment Profile Template Name
        """
        return pulumi.get(self, "segment_profile_template_name")

    @segment_profile_template_name.setter
    def segment_profile_template_name(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "segment_profile_template_name", value)

    @property
    @pulumi.getter(name="segmentSecurityProfileId")
    def segment_security_profile_id(self) -> Optional[pulumi.Input[str]]:
        """
        Segment Security Profile ID. Can be referenced using
        [`get_nsxt_segment_security_profile`](https://www.terraform.io/providers/vmware/vcd/latest/docs/data-sources/nsxt_segment_security_profile)
        data source.
        """
        return pulumi.get(self, "segment_security_profile_id")

    @segment_security_profile_id.setter
    def segment_security_profile_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "segment_security_profile_id", value)

    @property
    @pulumi.getter(name="spoofGuardProfileId")
    def spoof_guard_profile_id(self) -> Optional[pulumi.Input[str]]:
        """
        Spoof Guard Profile ID. Can be referenced using
        [`get_nsxt_segment_spoof_guard_profile`](https://www.terraform.io/providers/vmware/vcd/latest/docs/data-sources/nsxt_segment_spoof_guard_profile)
        data source.
        """
        return pulumi.get(self, "spoof_guard_profile_id")

    @spoof_guard_profile_id.setter
    def spoof_guard_profile_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "spoof_guard_profile_id", value)


class NsxtNetworkSegmentProfile(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 ip_discovery_profile_id: Optional[pulumi.Input[str]] = None,
                 mac_discovery_profile_id: Optional[pulumi.Input[str]] = None,
                 org: Optional[pulumi.Input[str]] = None,
                 org_network_id: Optional[pulumi.Input[str]] = None,
                 qos_profile_id: Optional[pulumi.Input[str]] = None,
                 segment_profile_template_id: Optional[pulumi.Input[str]] = None,
                 segment_security_profile_id: Optional[pulumi.Input[str]] = None,
                 spoof_guard_profile_id: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        """
        Create a NsxtNetworkSegmentProfile resource with the given unique name, props, and options.
        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] ip_discovery_profile_id: IP Discovery Profile ID. Can be referenced using
               [`get_nsxt_segment_ip_discovery_profile`](https://www.terraform.io/providers/vmware/vcd/latest/docs/data-sources/nsxt_segment_ip_discovery_profile)
               data source.
        :param pulumi.Input[str] mac_discovery_profile_id: MAC Discovery Profile ID. Can be referenced using
               [`get_nsxt_segment_mac_discovery_profile`](https://www.terraform.io/providers/vmware/vcd/latest/docs/data-sources/nsxt_segment_mac_discovery_profile)
               data source.
        :param pulumi.Input[str] org: The name of organization to use, optional if defined at provider level
        :param pulumi.Input[str] org_network_id: Org VDC Network ID
        :param pulumi.Input[str] qos_profile_id: QoS Profile ID. Can be referenced using
               [`get_nsxt_segment_qos_profile`](https://www.terraform.io/providers/vmware/vcd/latest/docs/data-sources/nsxt_segment_qos_profile)
               data source.
        :param pulumi.Input[str] segment_profile_template_id: Segment Profile Template ID to be applied for this Org
               VDC Network
        :param pulumi.Input[str] segment_security_profile_id: Segment Security Profile ID. Can be referenced using
               [`get_nsxt_segment_security_profile`](https://www.terraform.io/providers/vmware/vcd/latest/docs/data-sources/nsxt_segment_security_profile)
               data source.
        :param pulumi.Input[str] spoof_guard_profile_id: Spoof Guard Profile ID. Can be referenced using
               [`get_nsxt_segment_spoof_guard_profile`](https://www.terraform.io/providers/vmware/vcd/latest/docs/data-sources/nsxt_segment_spoof_guard_profile)
               data source.
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: NsxtNetworkSegmentProfileArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        Create a NsxtNetworkSegmentProfile resource with the given unique name, props, and options.
        :param str resource_name: The name of the resource.
        :param NsxtNetworkSegmentProfileArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(NsxtNetworkSegmentProfileArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 ip_discovery_profile_id: Optional[pulumi.Input[str]] = None,
                 mac_discovery_profile_id: Optional[pulumi.Input[str]] = None,
                 org: Optional[pulumi.Input[str]] = None,
                 org_network_id: Optional[pulumi.Input[str]] = None,
                 qos_profile_id: Optional[pulumi.Input[str]] = None,
                 segment_profile_template_id: Optional[pulumi.Input[str]] = None,
                 segment_security_profile_id: Optional[pulumi.Input[str]] = None,
                 spoof_guard_profile_id: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = NsxtNetworkSegmentProfileArgs.__new__(NsxtNetworkSegmentProfileArgs)

            __props__.__dict__["ip_discovery_profile_id"] = ip_discovery_profile_id
            __props__.__dict__["mac_discovery_profile_id"] = mac_discovery_profile_id
            __props__.__dict__["org"] = org
            if org_network_id is None and not opts.urn:
                raise TypeError("Missing required property 'org_network_id'")
            __props__.__dict__["org_network_id"] = org_network_id
            __props__.__dict__["qos_profile_id"] = qos_profile_id
            __props__.__dict__["segment_profile_template_id"] = segment_profile_template_id
            __props__.__dict__["segment_security_profile_id"] = segment_security_profile_id
            __props__.__dict__["spoof_guard_profile_id"] = spoof_guard_profile_id
            __props__.__dict__["segment_profile_template_name"] = None
        super(NsxtNetworkSegmentProfile, __self__).__init__(
            'vcd:index/nsxtNetworkSegmentProfile:NsxtNetworkSegmentProfile',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            ip_discovery_profile_id: Optional[pulumi.Input[str]] = None,
            mac_discovery_profile_id: Optional[pulumi.Input[str]] = None,
            org: Optional[pulumi.Input[str]] = None,
            org_network_id: Optional[pulumi.Input[str]] = None,
            qos_profile_id: Optional[pulumi.Input[str]] = None,
            segment_profile_template_id: Optional[pulumi.Input[str]] = None,
            segment_profile_template_name: Optional[pulumi.Input[str]] = None,
            segment_security_profile_id: Optional[pulumi.Input[str]] = None,
            spoof_guard_profile_id: Optional[pulumi.Input[str]] = None) -> 'NsxtNetworkSegmentProfile':
        """
        Get an existing NsxtNetworkSegmentProfile resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] ip_discovery_profile_id: IP Discovery Profile ID. Can be referenced using
               [`get_nsxt_segment_ip_discovery_profile`](https://www.terraform.io/providers/vmware/vcd/latest/docs/data-sources/nsxt_segment_ip_discovery_profile)
               data source.
        :param pulumi.Input[str] mac_discovery_profile_id: MAC Discovery Profile ID. Can be referenced using
               [`get_nsxt_segment_mac_discovery_profile`](https://www.terraform.io/providers/vmware/vcd/latest/docs/data-sources/nsxt_segment_mac_discovery_profile)
               data source.
        :param pulumi.Input[str] org: The name of organization to use, optional if defined at provider level
        :param pulumi.Input[str] org_network_id: Org VDC Network ID
        :param pulumi.Input[str] qos_profile_id: QoS Profile ID. Can be referenced using
               [`get_nsxt_segment_qos_profile`](https://www.terraform.io/providers/vmware/vcd/latest/docs/data-sources/nsxt_segment_qos_profile)
               data source.
        :param pulumi.Input[str] segment_profile_template_id: Segment Profile Template ID to be applied for this Org
               VDC Network
        :param pulumi.Input[str] segment_profile_template_name: Segment Profile Template Name
        :param pulumi.Input[str] segment_security_profile_id: Segment Security Profile ID. Can be referenced using
               [`get_nsxt_segment_security_profile`](https://www.terraform.io/providers/vmware/vcd/latest/docs/data-sources/nsxt_segment_security_profile)
               data source.
        :param pulumi.Input[str] spoof_guard_profile_id: Spoof Guard Profile ID. Can be referenced using
               [`get_nsxt_segment_spoof_guard_profile`](https://www.terraform.io/providers/vmware/vcd/latest/docs/data-sources/nsxt_segment_spoof_guard_profile)
               data source.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = _NsxtNetworkSegmentProfileState.__new__(_NsxtNetworkSegmentProfileState)

        __props__.__dict__["ip_discovery_profile_id"] = ip_discovery_profile_id
        __props__.__dict__["mac_discovery_profile_id"] = mac_discovery_profile_id
        __props__.__dict__["org"] = org
        __props__.__dict__["org_network_id"] = org_network_id
        __props__.__dict__["qos_profile_id"] = qos_profile_id
        __props__.__dict__["segment_profile_template_id"] = segment_profile_template_id
        __props__.__dict__["segment_profile_template_name"] = segment_profile_template_name
        __props__.__dict__["segment_security_profile_id"] = segment_security_profile_id
        __props__.__dict__["spoof_guard_profile_id"] = spoof_guard_profile_id
        return NsxtNetworkSegmentProfile(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter(name="ipDiscoveryProfileId")
    def ip_discovery_profile_id(self) -> pulumi.Output[str]:
        """
        IP Discovery Profile ID. Can be referenced using
        [`get_nsxt_segment_ip_discovery_profile`](https://www.terraform.io/providers/vmware/vcd/latest/docs/data-sources/nsxt_segment_ip_discovery_profile)
        data source.
        """
        return pulumi.get(self, "ip_discovery_profile_id")

    @property
    @pulumi.getter(name="macDiscoveryProfileId")
    def mac_discovery_profile_id(self) -> pulumi.Output[str]:
        """
        MAC Discovery Profile ID. Can be referenced using
        [`get_nsxt_segment_mac_discovery_profile`](https://www.terraform.io/providers/vmware/vcd/latest/docs/data-sources/nsxt_segment_mac_discovery_profile)
        data source.
        """
        return pulumi.get(self, "mac_discovery_profile_id")

    @property
    @pulumi.getter
    def org(self) -> pulumi.Output[Optional[str]]:
        """
        The name of organization to use, optional if defined at provider level
        """
        return pulumi.get(self, "org")

    @property
    @pulumi.getter(name="orgNetworkId")
    def org_network_id(self) -> pulumi.Output[str]:
        """
        Org VDC Network ID
        """
        return pulumi.get(self, "org_network_id")

    @property
    @pulumi.getter(name="qosProfileId")
    def qos_profile_id(self) -> pulumi.Output[str]:
        """
        QoS Profile ID. Can be referenced using
        [`get_nsxt_segment_qos_profile`](https://www.terraform.io/providers/vmware/vcd/latest/docs/data-sources/nsxt_segment_qos_profile)
        data source.
        """
        return pulumi.get(self, "qos_profile_id")

    @property
    @pulumi.getter(name="segmentProfileTemplateId")
    def segment_profile_template_id(self) -> pulumi.Output[Optional[str]]:
        """
        Segment Profile Template ID to be applied for this Org
        VDC Network
        """
        return pulumi.get(self, "segment_profile_template_id")

    @property
    @pulumi.getter(name="segmentProfileTemplateName")
    def segment_profile_template_name(self) -> pulumi.Output[str]:
        """
        Segment Profile Template Name
        """
        return pulumi.get(self, "segment_profile_template_name")

    @property
    @pulumi.getter(name="segmentSecurityProfileId")
    def segment_security_profile_id(self) -> pulumi.Output[str]:
        """
        Segment Security Profile ID. Can be referenced using
        [`get_nsxt_segment_security_profile`](https://www.terraform.io/providers/vmware/vcd/latest/docs/data-sources/nsxt_segment_security_profile)
        data source.
        """
        return pulumi.get(self, "segment_security_profile_id")

    @property
    @pulumi.getter(name="spoofGuardProfileId")
    def spoof_guard_profile_id(self) -> pulumi.Output[str]:
        """
        Spoof Guard Profile ID. Can be referenced using
        [`get_nsxt_segment_spoof_guard_profile`](https://www.terraform.io/providers/vmware/vcd/latest/docs/data-sources/nsxt_segment_spoof_guard_profile)
        data source.
        """
        return pulumi.get(self, "spoof_guard_profile_id")

