# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from . import _utilities

__all__ = ['NsxtSegmentProfileTemplateArgs', 'NsxtSegmentProfileTemplate']

@pulumi.input_type
class NsxtSegmentProfileTemplateArgs:
    def __init__(__self__, *,
                 nsxt_manager_id: pulumi.Input[str],
                 description: Optional[pulumi.Input[str]] = None,
                 ip_discovery_profile_id: Optional[pulumi.Input[str]] = None,
                 mac_discovery_profile_id: Optional[pulumi.Input[str]] = None,
                 name: Optional[pulumi.Input[str]] = None,
                 qos_profile_id: Optional[pulumi.Input[str]] = None,
                 segment_security_profile_id: Optional[pulumi.Input[str]] = None,
                 spoof_guard_profile_id: Optional[pulumi.Input[str]] = None):
        """
        The set of arguments for constructing a NsxtSegmentProfileTemplate resource.
        :param pulumi.Input[str] nsxt_manager_id: NSX-T Manager ID (can be referenced using
               [`get_nsxt_manager`](https://www.terraform.io/providers/vmware/vcd/latest/docs/data-sources/nsxt_manager) datasource)
        :param pulumi.Input[str] description: Description of Segment Profile Template
        :param pulumi.Input[str] ip_discovery_profile_id: IP Discovery Profile ID. can be referenced using
               [`get_nsxt_segment_ip_discovery_profile`](https://www.terraform.io/providers/vmware/vcd/latest/docs/data-sources/nsxt_segment_ip_discovery_profile)
        :param pulumi.Input[str] mac_discovery_profile_id: IP Discovery Profile ID. can be referenced using
               [`get_nsxt_segment_mac_discovery_profile`](https://www.terraform.io/providers/vmware/vcd/latest/docs/data-sources/nsxt_segment_mac_discovery_profile)
        :param pulumi.Input[str] name: Name for Segment Profile Template
        :param pulumi.Input[str] qos_profile_id: IP Discovery Profile ID. can be referenced using
               [`get_nsxt_segment_qos_profile`](https://www.terraform.io/providers/vmware/vcd/latest/docs/data-sources/nsxt_segment_qos_profile)
        :param pulumi.Input[str] segment_security_profile_id: IP Discovery Profile ID. can be referenced using
               [`get_nsxt_segment_security_profile`](https://www.terraform.io/providers/vmware/vcd/latest/docs/data-sources/nsxt_segment_security_profile)
        :param pulumi.Input[str] spoof_guard_profile_id: IP Discovery Profile ID. can be referenced using
               [`get_nsxt_segment_spoof_guard_profile`](https://www.terraform.io/providers/vmware/vcd/latest/docs/data-sources/nsxt_segment_spoof_guard_profile)
        """
        pulumi.set(__self__, "nsxt_manager_id", nsxt_manager_id)
        if description is not None:
            pulumi.set(__self__, "description", description)
        if ip_discovery_profile_id is not None:
            pulumi.set(__self__, "ip_discovery_profile_id", ip_discovery_profile_id)
        if mac_discovery_profile_id is not None:
            pulumi.set(__self__, "mac_discovery_profile_id", mac_discovery_profile_id)
        if name is not None:
            pulumi.set(__self__, "name", name)
        if qos_profile_id is not None:
            pulumi.set(__self__, "qos_profile_id", qos_profile_id)
        if segment_security_profile_id is not None:
            pulumi.set(__self__, "segment_security_profile_id", segment_security_profile_id)
        if spoof_guard_profile_id is not None:
            pulumi.set(__self__, "spoof_guard_profile_id", spoof_guard_profile_id)

    @property
    @pulumi.getter(name="nsxtManagerId")
    def nsxt_manager_id(self) -> pulumi.Input[str]:
        """
        NSX-T Manager ID (can be referenced using
        [`get_nsxt_manager`](https://www.terraform.io/providers/vmware/vcd/latest/docs/data-sources/nsxt_manager) datasource)
        """
        return pulumi.get(self, "nsxt_manager_id")

    @nsxt_manager_id.setter
    def nsxt_manager_id(self, value: pulumi.Input[str]):
        pulumi.set(self, "nsxt_manager_id", value)

    @property
    @pulumi.getter
    def description(self) -> Optional[pulumi.Input[str]]:
        """
        Description of Segment Profile Template
        """
        return pulumi.get(self, "description")

    @description.setter
    def description(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "description", value)

    @property
    @pulumi.getter(name="ipDiscoveryProfileId")
    def ip_discovery_profile_id(self) -> Optional[pulumi.Input[str]]:
        """
        IP Discovery Profile ID. can be referenced using
        [`get_nsxt_segment_ip_discovery_profile`](https://www.terraform.io/providers/vmware/vcd/latest/docs/data-sources/nsxt_segment_ip_discovery_profile)
        """
        return pulumi.get(self, "ip_discovery_profile_id")

    @ip_discovery_profile_id.setter
    def ip_discovery_profile_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "ip_discovery_profile_id", value)

    @property
    @pulumi.getter(name="macDiscoveryProfileId")
    def mac_discovery_profile_id(self) -> Optional[pulumi.Input[str]]:
        """
        IP Discovery Profile ID. can be referenced using
        [`get_nsxt_segment_mac_discovery_profile`](https://www.terraform.io/providers/vmware/vcd/latest/docs/data-sources/nsxt_segment_mac_discovery_profile)
        """
        return pulumi.get(self, "mac_discovery_profile_id")

    @mac_discovery_profile_id.setter
    def mac_discovery_profile_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "mac_discovery_profile_id", value)

    @property
    @pulumi.getter
    def name(self) -> Optional[pulumi.Input[str]]:
        """
        Name for Segment Profile Template
        """
        return pulumi.get(self, "name")

    @name.setter
    def name(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "name", value)

    @property
    @pulumi.getter(name="qosProfileId")
    def qos_profile_id(self) -> Optional[pulumi.Input[str]]:
        """
        IP Discovery Profile ID. can be referenced using
        [`get_nsxt_segment_qos_profile`](https://www.terraform.io/providers/vmware/vcd/latest/docs/data-sources/nsxt_segment_qos_profile)
        """
        return pulumi.get(self, "qos_profile_id")

    @qos_profile_id.setter
    def qos_profile_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "qos_profile_id", value)

    @property
    @pulumi.getter(name="segmentSecurityProfileId")
    def segment_security_profile_id(self) -> Optional[pulumi.Input[str]]:
        """
        IP Discovery Profile ID. can be referenced using
        [`get_nsxt_segment_security_profile`](https://www.terraform.io/providers/vmware/vcd/latest/docs/data-sources/nsxt_segment_security_profile)
        """
        return pulumi.get(self, "segment_security_profile_id")

    @segment_security_profile_id.setter
    def segment_security_profile_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "segment_security_profile_id", value)

    @property
    @pulumi.getter(name="spoofGuardProfileId")
    def spoof_guard_profile_id(self) -> Optional[pulumi.Input[str]]:
        """
        IP Discovery Profile ID. can be referenced using
        [`get_nsxt_segment_spoof_guard_profile`](https://www.terraform.io/providers/vmware/vcd/latest/docs/data-sources/nsxt_segment_spoof_guard_profile)
        """
        return pulumi.get(self, "spoof_guard_profile_id")

    @spoof_guard_profile_id.setter
    def spoof_guard_profile_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "spoof_guard_profile_id", value)


@pulumi.input_type
class _NsxtSegmentProfileTemplateState:
    def __init__(__self__, *,
                 description: Optional[pulumi.Input[str]] = None,
                 ip_discovery_profile_id: Optional[pulumi.Input[str]] = None,
                 mac_discovery_profile_id: Optional[pulumi.Input[str]] = None,
                 name: Optional[pulumi.Input[str]] = None,
                 nsxt_manager_id: Optional[pulumi.Input[str]] = None,
                 qos_profile_id: Optional[pulumi.Input[str]] = None,
                 segment_security_profile_id: Optional[pulumi.Input[str]] = None,
                 spoof_guard_profile_id: Optional[pulumi.Input[str]] = None):
        """
        Input properties used for looking up and filtering NsxtSegmentProfileTemplate resources.
        :param pulumi.Input[str] description: Description of Segment Profile Template
        :param pulumi.Input[str] ip_discovery_profile_id: IP Discovery Profile ID. can be referenced using
               [`get_nsxt_segment_ip_discovery_profile`](https://www.terraform.io/providers/vmware/vcd/latest/docs/data-sources/nsxt_segment_ip_discovery_profile)
        :param pulumi.Input[str] mac_discovery_profile_id: IP Discovery Profile ID. can be referenced using
               [`get_nsxt_segment_mac_discovery_profile`](https://www.terraform.io/providers/vmware/vcd/latest/docs/data-sources/nsxt_segment_mac_discovery_profile)
        :param pulumi.Input[str] name: Name for Segment Profile Template
        :param pulumi.Input[str] nsxt_manager_id: NSX-T Manager ID (can be referenced using
               [`get_nsxt_manager`](https://www.terraform.io/providers/vmware/vcd/latest/docs/data-sources/nsxt_manager) datasource)
        :param pulumi.Input[str] qos_profile_id: IP Discovery Profile ID. can be referenced using
               [`get_nsxt_segment_qos_profile`](https://www.terraform.io/providers/vmware/vcd/latest/docs/data-sources/nsxt_segment_qos_profile)
        :param pulumi.Input[str] segment_security_profile_id: IP Discovery Profile ID. can be referenced using
               [`get_nsxt_segment_security_profile`](https://www.terraform.io/providers/vmware/vcd/latest/docs/data-sources/nsxt_segment_security_profile)
        :param pulumi.Input[str] spoof_guard_profile_id: IP Discovery Profile ID. can be referenced using
               [`get_nsxt_segment_spoof_guard_profile`](https://www.terraform.io/providers/vmware/vcd/latest/docs/data-sources/nsxt_segment_spoof_guard_profile)
        """
        if description is not None:
            pulumi.set(__self__, "description", description)
        if ip_discovery_profile_id is not None:
            pulumi.set(__self__, "ip_discovery_profile_id", ip_discovery_profile_id)
        if mac_discovery_profile_id is not None:
            pulumi.set(__self__, "mac_discovery_profile_id", mac_discovery_profile_id)
        if name is not None:
            pulumi.set(__self__, "name", name)
        if nsxt_manager_id is not None:
            pulumi.set(__self__, "nsxt_manager_id", nsxt_manager_id)
        if qos_profile_id is not None:
            pulumi.set(__self__, "qos_profile_id", qos_profile_id)
        if segment_security_profile_id is not None:
            pulumi.set(__self__, "segment_security_profile_id", segment_security_profile_id)
        if spoof_guard_profile_id is not None:
            pulumi.set(__self__, "spoof_guard_profile_id", spoof_guard_profile_id)

    @property
    @pulumi.getter
    def description(self) -> Optional[pulumi.Input[str]]:
        """
        Description of Segment Profile Template
        """
        return pulumi.get(self, "description")

    @description.setter
    def description(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "description", value)

    @property
    @pulumi.getter(name="ipDiscoveryProfileId")
    def ip_discovery_profile_id(self) -> Optional[pulumi.Input[str]]:
        """
        IP Discovery Profile ID. can be referenced using
        [`get_nsxt_segment_ip_discovery_profile`](https://www.terraform.io/providers/vmware/vcd/latest/docs/data-sources/nsxt_segment_ip_discovery_profile)
        """
        return pulumi.get(self, "ip_discovery_profile_id")

    @ip_discovery_profile_id.setter
    def ip_discovery_profile_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "ip_discovery_profile_id", value)

    @property
    @pulumi.getter(name="macDiscoveryProfileId")
    def mac_discovery_profile_id(self) -> Optional[pulumi.Input[str]]:
        """
        IP Discovery Profile ID. can be referenced using
        [`get_nsxt_segment_mac_discovery_profile`](https://www.terraform.io/providers/vmware/vcd/latest/docs/data-sources/nsxt_segment_mac_discovery_profile)
        """
        return pulumi.get(self, "mac_discovery_profile_id")

    @mac_discovery_profile_id.setter
    def mac_discovery_profile_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "mac_discovery_profile_id", value)

    @property
    @pulumi.getter
    def name(self) -> Optional[pulumi.Input[str]]:
        """
        Name for Segment Profile Template
        """
        return pulumi.get(self, "name")

    @name.setter
    def name(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "name", value)

    @property
    @pulumi.getter(name="nsxtManagerId")
    def nsxt_manager_id(self) -> Optional[pulumi.Input[str]]:
        """
        NSX-T Manager ID (can be referenced using
        [`get_nsxt_manager`](https://www.terraform.io/providers/vmware/vcd/latest/docs/data-sources/nsxt_manager) datasource)
        """
        return pulumi.get(self, "nsxt_manager_id")

    @nsxt_manager_id.setter
    def nsxt_manager_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "nsxt_manager_id", value)

    @property
    @pulumi.getter(name="qosProfileId")
    def qos_profile_id(self) -> Optional[pulumi.Input[str]]:
        """
        IP Discovery Profile ID. can be referenced using
        [`get_nsxt_segment_qos_profile`](https://www.terraform.io/providers/vmware/vcd/latest/docs/data-sources/nsxt_segment_qos_profile)
        """
        return pulumi.get(self, "qos_profile_id")

    @qos_profile_id.setter
    def qos_profile_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "qos_profile_id", value)

    @property
    @pulumi.getter(name="segmentSecurityProfileId")
    def segment_security_profile_id(self) -> Optional[pulumi.Input[str]]:
        """
        IP Discovery Profile ID. can be referenced using
        [`get_nsxt_segment_security_profile`](https://www.terraform.io/providers/vmware/vcd/latest/docs/data-sources/nsxt_segment_security_profile)
        """
        return pulumi.get(self, "segment_security_profile_id")

    @segment_security_profile_id.setter
    def segment_security_profile_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "segment_security_profile_id", value)

    @property
    @pulumi.getter(name="spoofGuardProfileId")
    def spoof_guard_profile_id(self) -> Optional[pulumi.Input[str]]:
        """
        IP Discovery Profile ID. can be referenced using
        [`get_nsxt_segment_spoof_guard_profile`](https://www.terraform.io/providers/vmware/vcd/latest/docs/data-sources/nsxt_segment_spoof_guard_profile)
        """
        return pulumi.get(self, "spoof_guard_profile_id")

    @spoof_guard_profile_id.setter
    def spoof_guard_profile_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "spoof_guard_profile_id", value)


class NsxtSegmentProfileTemplate(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 description: Optional[pulumi.Input[str]] = None,
                 ip_discovery_profile_id: Optional[pulumi.Input[str]] = None,
                 mac_discovery_profile_id: Optional[pulumi.Input[str]] = None,
                 name: Optional[pulumi.Input[str]] = None,
                 nsxt_manager_id: Optional[pulumi.Input[str]] = None,
                 qos_profile_id: Optional[pulumi.Input[str]] = None,
                 segment_security_profile_id: Optional[pulumi.Input[str]] = None,
                 spoof_guard_profile_id: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        """
        Create a NsxtSegmentProfileTemplate resource with the given unique name, props, and options.
        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] description: Description of Segment Profile Template
        :param pulumi.Input[str] ip_discovery_profile_id: IP Discovery Profile ID. can be referenced using
               [`get_nsxt_segment_ip_discovery_profile`](https://www.terraform.io/providers/vmware/vcd/latest/docs/data-sources/nsxt_segment_ip_discovery_profile)
        :param pulumi.Input[str] mac_discovery_profile_id: IP Discovery Profile ID. can be referenced using
               [`get_nsxt_segment_mac_discovery_profile`](https://www.terraform.io/providers/vmware/vcd/latest/docs/data-sources/nsxt_segment_mac_discovery_profile)
        :param pulumi.Input[str] name: Name for Segment Profile Template
        :param pulumi.Input[str] nsxt_manager_id: NSX-T Manager ID (can be referenced using
               [`get_nsxt_manager`](https://www.terraform.io/providers/vmware/vcd/latest/docs/data-sources/nsxt_manager) datasource)
        :param pulumi.Input[str] qos_profile_id: IP Discovery Profile ID. can be referenced using
               [`get_nsxt_segment_qos_profile`](https://www.terraform.io/providers/vmware/vcd/latest/docs/data-sources/nsxt_segment_qos_profile)
        :param pulumi.Input[str] segment_security_profile_id: IP Discovery Profile ID. can be referenced using
               [`get_nsxt_segment_security_profile`](https://www.terraform.io/providers/vmware/vcd/latest/docs/data-sources/nsxt_segment_security_profile)
        :param pulumi.Input[str] spoof_guard_profile_id: IP Discovery Profile ID. can be referenced using
               [`get_nsxt_segment_spoof_guard_profile`](https://www.terraform.io/providers/vmware/vcd/latest/docs/data-sources/nsxt_segment_spoof_guard_profile)
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: NsxtSegmentProfileTemplateArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        Create a NsxtSegmentProfileTemplate resource with the given unique name, props, and options.
        :param str resource_name: The name of the resource.
        :param NsxtSegmentProfileTemplateArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(NsxtSegmentProfileTemplateArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 description: Optional[pulumi.Input[str]] = None,
                 ip_discovery_profile_id: Optional[pulumi.Input[str]] = None,
                 mac_discovery_profile_id: Optional[pulumi.Input[str]] = None,
                 name: Optional[pulumi.Input[str]] = None,
                 nsxt_manager_id: Optional[pulumi.Input[str]] = None,
                 qos_profile_id: Optional[pulumi.Input[str]] = None,
                 segment_security_profile_id: Optional[pulumi.Input[str]] = None,
                 spoof_guard_profile_id: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = NsxtSegmentProfileTemplateArgs.__new__(NsxtSegmentProfileTemplateArgs)

            __props__.__dict__["description"] = description
            __props__.__dict__["ip_discovery_profile_id"] = ip_discovery_profile_id
            __props__.__dict__["mac_discovery_profile_id"] = mac_discovery_profile_id
            __props__.__dict__["name"] = name
            if nsxt_manager_id is None and not opts.urn:
                raise TypeError("Missing required property 'nsxt_manager_id'")
            __props__.__dict__["nsxt_manager_id"] = nsxt_manager_id
            __props__.__dict__["qos_profile_id"] = qos_profile_id
            __props__.__dict__["segment_security_profile_id"] = segment_security_profile_id
            __props__.__dict__["spoof_guard_profile_id"] = spoof_guard_profile_id
        super(NsxtSegmentProfileTemplate, __self__).__init__(
            'vcd:index/nsxtSegmentProfileTemplate:NsxtSegmentProfileTemplate',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            description: Optional[pulumi.Input[str]] = None,
            ip_discovery_profile_id: Optional[pulumi.Input[str]] = None,
            mac_discovery_profile_id: Optional[pulumi.Input[str]] = None,
            name: Optional[pulumi.Input[str]] = None,
            nsxt_manager_id: Optional[pulumi.Input[str]] = None,
            qos_profile_id: Optional[pulumi.Input[str]] = None,
            segment_security_profile_id: Optional[pulumi.Input[str]] = None,
            spoof_guard_profile_id: Optional[pulumi.Input[str]] = None) -> 'NsxtSegmentProfileTemplate':
        """
        Get an existing NsxtSegmentProfileTemplate resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] description: Description of Segment Profile Template
        :param pulumi.Input[str] ip_discovery_profile_id: IP Discovery Profile ID. can be referenced using
               [`get_nsxt_segment_ip_discovery_profile`](https://www.terraform.io/providers/vmware/vcd/latest/docs/data-sources/nsxt_segment_ip_discovery_profile)
        :param pulumi.Input[str] mac_discovery_profile_id: IP Discovery Profile ID. can be referenced using
               [`get_nsxt_segment_mac_discovery_profile`](https://www.terraform.io/providers/vmware/vcd/latest/docs/data-sources/nsxt_segment_mac_discovery_profile)
        :param pulumi.Input[str] name: Name for Segment Profile Template
        :param pulumi.Input[str] nsxt_manager_id: NSX-T Manager ID (can be referenced using
               [`get_nsxt_manager`](https://www.terraform.io/providers/vmware/vcd/latest/docs/data-sources/nsxt_manager) datasource)
        :param pulumi.Input[str] qos_profile_id: IP Discovery Profile ID. can be referenced using
               [`get_nsxt_segment_qos_profile`](https://www.terraform.io/providers/vmware/vcd/latest/docs/data-sources/nsxt_segment_qos_profile)
        :param pulumi.Input[str] segment_security_profile_id: IP Discovery Profile ID. can be referenced using
               [`get_nsxt_segment_security_profile`](https://www.terraform.io/providers/vmware/vcd/latest/docs/data-sources/nsxt_segment_security_profile)
        :param pulumi.Input[str] spoof_guard_profile_id: IP Discovery Profile ID. can be referenced using
               [`get_nsxt_segment_spoof_guard_profile`](https://www.terraform.io/providers/vmware/vcd/latest/docs/data-sources/nsxt_segment_spoof_guard_profile)
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = _NsxtSegmentProfileTemplateState.__new__(_NsxtSegmentProfileTemplateState)

        __props__.__dict__["description"] = description
        __props__.__dict__["ip_discovery_profile_id"] = ip_discovery_profile_id
        __props__.__dict__["mac_discovery_profile_id"] = mac_discovery_profile_id
        __props__.__dict__["name"] = name
        __props__.__dict__["nsxt_manager_id"] = nsxt_manager_id
        __props__.__dict__["qos_profile_id"] = qos_profile_id
        __props__.__dict__["segment_security_profile_id"] = segment_security_profile_id
        __props__.__dict__["spoof_guard_profile_id"] = spoof_guard_profile_id
        return NsxtSegmentProfileTemplate(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter
    def description(self) -> pulumi.Output[Optional[str]]:
        """
        Description of Segment Profile Template
        """
        return pulumi.get(self, "description")

    @property
    @pulumi.getter(name="ipDiscoveryProfileId")
    def ip_discovery_profile_id(self) -> pulumi.Output[Optional[str]]:
        """
        IP Discovery Profile ID. can be referenced using
        [`get_nsxt_segment_ip_discovery_profile`](https://www.terraform.io/providers/vmware/vcd/latest/docs/data-sources/nsxt_segment_ip_discovery_profile)
        """
        return pulumi.get(self, "ip_discovery_profile_id")

    @property
    @pulumi.getter(name="macDiscoveryProfileId")
    def mac_discovery_profile_id(self) -> pulumi.Output[Optional[str]]:
        """
        IP Discovery Profile ID. can be referenced using
        [`get_nsxt_segment_mac_discovery_profile`](https://www.terraform.io/providers/vmware/vcd/latest/docs/data-sources/nsxt_segment_mac_discovery_profile)
        """
        return pulumi.get(self, "mac_discovery_profile_id")

    @property
    @pulumi.getter
    def name(self) -> pulumi.Output[str]:
        """
        Name for Segment Profile Template
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter(name="nsxtManagerId")
    def nsxt_manager_id(self) -> pulumi.Output[str]:
        """
        NSX-T Manager ID (can be referenced using
        [`get_nsxt_manager`](https://www.terraform.io/providers/vmware/vcd/latest/docs/data-sources/nsxt_manager) datasource)
        """
        return pulumi.get(self, "nsxt_manager_id")

    @property
    @pulumi.getter(name="qosProfileId")
    def qos_profile_id(self) -> pulumi.Output[Optional[str]]:
        """
        IP Discovery Profile ID. can be referenced using
        [`get_nsxt_segment_qos_profile`](https://www.terraform.io/providers/vmware/vcd/latest/docs/data-sources/nsxt_segment_qos_profile)
        """
        return pulumi.get(self, "qos_profile_id")

    @property
    @pulumi.getter(name="segmentSecurityProfileId")
    def segment_security_profile_id(self) -> pulumi.Output[Optional[str]]:
        """
        IP Discovery Profile ID. can be referenced using
        [`get_nsxt_segment_security_profile`](https://www.terraform.io/providers/vmware/vcd/latest/docs/data-sources/nsxt_segment_security_profile)
        """
        return pulumi.get(self, "segment_security_profile_id")

    @property
    @pulumi.getter(name="spoofGuardProfileId")
    def spoof_guard_profile_id(self) -> pulumi.Output[Optional[str]]:
        """
        IP Discovery Profile ID. can be referenced using
        [`get_nsxt_segment_spoof_guard_profile`](https://www.terraform.io/providers/vmware/vcd/latest/docs/data-sources/nsxt_segment_spoof_guard_profile)
        """
        return pulumi.get(self, "spoof_guard_profile_id")

