# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from . import _utilities
from . import outputs
from ._inputs import *

__all__ = ['VappAccessControlArgs', 'VappAccessControl']

@pulumi.input_type
class VappAccessControlArgs:
    def __init__(__self__, *,
                 shared_with_everyone: pulumi.Input[bool],
                 vapp_id: pulumi.Input[str],
                 everyone_access_level: Optional[pulumi.Input[str]] = None,
                 org: Optional[pulumi.Input[str]] = None,
                 shared_withs: Optional[pulumi.Input[Sequence[pulumi.Input['VappAccessControlSharedWithArgs']]]] = None,
                 vdc: Optional[pulumi.Input[str]] = None):
        """
        The set of arguments for constructing a VappAccessControl resource.
        :param pulumi.Input[bool] shared_with_everyone: Whether the vApp is shared with everyone. If any `shared_with` blocks are included,
               this property must be set to `false`.
        :param pulumi.Input[str] vapp_id: A unique identifier for the vApp.
        :param pulumi.Input[str] everyone_access_level: Access level when the vApp is shared with everyone (one of `ReadOnly`, `Change`, 
               `FullControl`). Required if `shared_with_everyone` is `true`.
        :param pulumi.Input[str] org: The name of organization to which the vApp belongs. Optional if defined at provider level.
        :param pulumi.Input[Sequence[pulumi.Input['VappAccessControlSharedWithArgs']]] shared_withs: one or more blocks defining a subject to which we are sharing. 
               See shared_with below for detail. It cannot be used if `shared_with_everyone` is set.
        :param pulumi.Input[str] vdc: The name of organization to which the vApp belongs. Optional if defined at provider level.
        """
        pulumi.set(__self__, "shared_with_everyone", shared_with_everyone)
        pulumi.set(__self__, "vapp_id", vapp_id)
        if everyone_access_level is not None:
            pulumi.set(__self__, "everyone_access_level", everyone_access_level)
        if org is not None:
            pulumi.set(__self__, "org", org)
        if shared_withs is not None:
            pulumi.set(__self__, "shared_withs", shared_withs)
        if vdc is not None:
            pulumi.set(__self__, "vdc", vdc)

    @property
    @pulumi.getter(name="sharedWithEveryone")
    def shared_with_everyone(self) -> pulumi.Input[bool]:
        """
        Whether the vApp is shared with everyone. If any `shared_with` blocks are included,
        this property must be set to `false`.
        """
        return pulumi.get(self, "shared_with_everyone")

    @shared_with_everyone.setter
    def shared_with_everyone(self, value: pulumi.Input[bool]):
        pulumi.set(self, "shared_with_everyone", value)

    @property
    @pulumi.getter(name="vappId")
    def vapp_id(self) -> pulumi.Input[str]:
        """
        A unique identifier for the vApp.
        """
        return pulumi.get(self, "vapp_id")

    @vapp_id.setter
    def vapp_id(self, value: pulumi.Input[str]):
        pulumi.set(self, "vapp_id", value)

    @property
    @pulumi.getter(name="everyoneAccessLevel")
    def everyone_access_level(self) -> Optional[pulumi.Input[str]]:
        """
        Access level when the vApp is shared with everyone (one of `ReadOnly`, `Change`, 
        `FullControl`). Required if `shared_with_everyone` is `true`.
        """
        return pulumi.get(self, "everyone_access_level")

    @everyone_access_level.setter
    def everyone_access_level(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "everyone_access_level", value)

    @property
    @pulumi.getter
    def org(self) -> Optional[pulumi.Input[str]]:
        """
        The name of organization to which the vApp belongs. Optional if defined at provider level.
        """
        return pulumi.get(self, "org")

    @org.setter
    def org(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "org", value)

    @property
    @pulumi.getter(name="sharedWiths")
    def shared_withs(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['VappAccessControlSharedWithArgs']]]]:
        """
        one or more blocks defining a subject to which we are sharing. 
        See shared_with below for detail. It cannot be used if `shared_with_everyone` is set.
        """
        return pulumi.get(self, "shared_withs")

    @shared_withs.setter
    def shared_withs(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['VappAccessControlSharedWithArgs']]]]):
        pulumi.set(self, "shared_withs", value)

    @property
    @pulumi.getter
    def vdc(self) -> Optional[pulumi.Input[str]]:
        """
        The name of organization to which the vApp belongs. Optional if defined at provider level.
        """
        return pulumi.get(self, "vdc")

    @vdc.setter
    def vdc(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "vdc", value)


@pulumi.input_type
class _VappAccessControlState:
    def __init__(__self__, *,
                 everyone_access_level: Optional[pulumi.Input[str]] = None,
                 org: Optional[pulumi.Input[str]] = None,
                 shared_with_everyone: Optional[pulumi.Input[bool]] = None,
                 shared_withs: Optional[pulumi.Input[Sequence[pulumi.Input['VappAccessControlSharedWithArgs']]]] = None,
                 vapp_id: Optional[pulumi.Input[str]] = None,
                 vdc: Optional[pulumi.Input[str]] = None):
        """
        Input properties used for looking up and filtering VappAccessControl resources.
        :param pulumi.Input[str] everyone_access_level: Access level when the vApp is shared with everyone (one of `ReadOnly`, `Change`, 
               `FullControl`). Required if `shared_with_everyone` is `true`.
        :param pulumi.Input[str] org: The name of organization to which the vApp belongs. Optional if defined at provider level.
        :param pulumi.Input[bool] shared_with_everyone: Whether the vApp is shared with everyone. If any `shared_with` blocks are included,
               this property must be set to `false`.
        :param pulumi.Input[Sequence[pulumi.Input['VappAccessControlSharedWithArgs']]] shared_withs: one or more blocks defining a subject to which we are sharing. 
               See shared_with below for detail. It cannot be used if `shared_with_everyone` is set.
        :param pulumi.Input[str] vapp_id: A unique identifier for the vApp.
        :param pulumi.Input[str] vdc: The name of organization to which the vApp belongs. Optional if defined at provider level.
        """
        if everyone_access_level is not None:
            pulumi.set(__self__, "everyone_access_level", everyone_access_level)
        if org is not None:
            pulumi.set(__self__, "org", org)
        if shared_with_everyone is not None:
            pulumi.set(__self__, "shared_with_everyone", shared_with_everyone)
        if shared_withs is not None:
            pulumi.set(__self__, "shared_withs", shared_withs)
        if vapp_id is not None:
            pulumi.set(__self__, "vapp_id", vapp_id)
        if vdc is not None:
            pulumi.set(__self__, "vdc", vdc)

    @property
    @pulumi.getter(name="everyoneAccessLevel")
    def everyone_access_level(self) -> Optional[pulumi.Input[str]]:
        """
        Access level when the vApp is shared with everyone (one of `ReadOnly`, `Change`, 
        `FullControl`). Required if `shared_with_everyone` is `true`.
        """
        return pulumi.get(self, "everyone_access_level")

    @everyone_access_level.setter
    def everyone_access_level(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "everyone_access_level", value)

    @property
    @pulumi.getter
    def org(self) -> Optional[pulumi.Input[str]]:
        """
        The name of organization to which the vApp belongs. Optional if defined at provider level.
        """
        return pulumi.get(self, "org")

    @org.setter
    def org(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "org", value)

    @property
    @pulumi.getter(name="sharedWithEveryone")
    def shared_with_everyone(self) -> Optional[pulumi.Input[bool]]:
        """
        Whether the vApp is shared with everyone. If any `shared_with` blocks are included,
        this property must be set to `false`.
        """
        return pulumi.get(self, "shared_with_everyone")

    @shared_with_everyone.setter
    def shared_with_everyone(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "shared_with_everyone", value)

    @property
    @pulumi.getter(name="sharedWiths")
    def shared_withs(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['VappAccessControlSharedWithArgs']]]]:
        """
        one or more blocks defining a subject to which we are sharing. 
        See shared_with below for detail. It cannot be used if `shared_with_everyone` is set.
        """
        return pulumi.get(self, "shared_withs")

    @shared_withs.setter
    def shared_withs(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['VappAccessControlSharedWithArgs']]]]):
        pulumi.set(self, "shared_withs", value)

    @property
    @pulumi.getter(name="vappId")
    def vapp_id(self) -> Optional[pulumi.Input[str]]:
        """
        A unique identifier for the vApp.
        """
        return pulumi.get(self, "vapp_id")

    @vapp_id.setter
    def vapp_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "vapp_id", value)

    @property
    @pulumi.getter
    def vdc(self) -> Optional[pulumi.Input[str]]:
        """
        The name of organization to which the vApp belongs. Optional if defined at provider level.
        """
        return pulumi.get(self, "vdc")

    @vdc.setter
    def vdc(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "vdc", value)


class VappAccessControl(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 everyone_access_level: Optional[pulumi.Input[str]] = None,
                 org: Optional[pulumi.Input[str]] = None,
                 shared_with_everyone: Optional[pulumi.Input[bool]] = None,
                 shared_withs: Optional[pulumi.Input[Sequence[pulumi.Input[Union['VappAccessControlSharedWithArgs', 'VappAccessControlSharedWithArgsDict']]]]] = None,
                 vapp_id: Optional[pulumi.Input[str]] = None,
                 vdc: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        """
        Create a VappAccessControl resource with the given unique name, props, and options.
        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] everyone_access_level: Access level when the vApp is shared with everyone (one of `ReadOnly`, `Change`, 
               `FullControl`). Required if `shared_with_everyone` is `true`.
        :param pulumi.Input[str] org: The name of organization to which the vApp belongs. Optional if defined at provider level.
        :param pulumi.Input[bool] shared_with_everyone: Whether the vApp is shared with everyone. If any `shared_with` blocks are included,
               this property must be set to `false`.
        :param pulumi.Input[Sequence[pulumi.Input[Union['VappAccessControlSharedWithArgs', 'VappAccessControlSharedWithArgsDict']]]] shared_withs: one or more blocks defining a subject to which we are sharing. 
               See shared_with below for detail. It cannot be used if `shared_with_everyone` is set.
        :param pulumi.Input[str] vapp_id: A unique identifier for the vApp.
        :param pulumi.Input[str] vdc: The name of organization to which the vApp belongs. Optional if defined at provider level.
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: VappAccessControlArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        Create a VappAccessControl resource with the given unique name, props, and options.
        :param str resource_name: The name of the resource.
        :param VappAccessControlArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(VappAccessControlArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 everyone_access_level: Optional[pulumi.Input[str]] = None,
                 org: Optional[pulumi.Input[str]] = None,
                 shared_with_everyone: Optional[pulumi.Input[bool]] = None,
                 shared_withs: Optional[pulumi.Input[Sequence[pulumi.Input[Union['VappAccessControlSharedWithArgs', 'VappAccessControlSharedWithArgsDict']]]]] = None,
                 vapp_id: Optional[pulumi.Input[str]] = None,
                 vdc: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = VappAccessControlArgs.__new__(VappAccessControlArgs)

            __props__.__dict__["everyone_access_level"] = everyone_access_level
            __props__.__dict__["org"] = org
            if shared_with_everyone is None and not opts.urn:
                raise TypeError("Missing required property 'shared_with_everyone'")
            __props__.__dict__["shared_with_everyone"] = shared_with_everyone
            __props__.__dict__["shared_withs"] = shared_withs
            if vapp_id is None and not opts.urn:
                raise TypeError("Missing required property 'vapp_id'")
            __props__.__dict__["vapp_id"] = vapp_id
            __props__.__dict__["vdc"] = vdc
        super(VappAccessControl, __self__).__init__(
            'vcd:index/vappAccessControl:VappAccessControl',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            everyone_access_level: Optional[pulumi.Input[str]] = None,
            org: Optional[pulumi.Input[str]] = None,
            shared_with_everyone: Optional[pulumi.Input[bool]] = None,
            shared_withs: Optional[pulumi.Input[Sequence[pulumi.Input[Union['VappAccessControlSharedWithArgs', 'VappAccessControlSharedWithArgsDict']]]]] = None,
            vapp_id: Optional[pulumi.Input[str]] = None,
            vdc: Optional[pulumi.Input[str]] = None) -> 'VappAccessControl':
        """
        Get an existing VappAccessControl resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] everyone_access_level: Access level when the vApp is shared with everyone (one of `ReadOnly`, `Change`, 
               `FullControl`). Required if `shared_with_everyone` is `true`.
        :param pulumi.Input[str] org: The name of organization to which the vApp belongs. Optional if defined at provider level.
        :param pulumi.Input[bool] shared_with_everyone: Whether the vApp is shared with everyone. If any `shared_with` blocks are included,
               this property must be set to `false`.
        :param pulumi.Input[Sequence[pulumi.Input[Union['VappAccessControlSharedWithArgs', 'VappAccessControlSharedWithArgsDict']]]] shared_withs: one or more blocks defining a subject to which we are sharing. 
               See shared_with below for detail. It cannot be used if `shared_with_everyone` is set.
        :param pulumi.Input[str] vapp_id: A unique identifier for the vApp.
        :param pulumi.Input[str] vdc: The name of organization to which the vApp belongs. Optional if defined at provider level.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = _VappAccessControlState.__new__(_VappAccessControlState)

        __props__.__dict__["everyone_access_level"] = everyone_access_level
        __props__.__dict__["org"] = org
        __props__.__dict__["shared_with_everyone"] = shared_with_everyone
        __props__.__dict__["shared_withs"] = shared_withs
        __props__.__dict__["vapp_id"] = vapp_id
        __props__.__dict__["vdc"] = vdc
        return VappAccessControl(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter(name="everyoneAccessLevel")
    def everyone_access_level(self) -> pulumi.Output[Optional[str]]:
        """
        Access level when the vApp is shared with everyone (one of `ReadOnly`, `Change`, 
        `FullControl`). Required if `shared_with_everyone` is `true`.
        """
        return pulumi.get(self, "everyone_access_level")

    @property
    @pulumi.getter
    def org(self) -> pulumi.Output[Optional[str]]:
        """
        The name of organization to which the vApp belongs. Optional if defined at provider level.
        """
        return pulumi.get(self, "org")

    @property
    @pulumi.getter(name="sharedWithEveryone")
    def shared_with_everyone(self) -> pulumi.Output[bool]:
        """
        Whether the vApp is shared with everyone. If any `shared_with` blocks are included,
        this property must be set to `false`.
        """
        return pulumi.get(self, "shared_with_everyone")

    @property
    @pulumi.getter(name="sharedWiths")
    def shared_withs(self) -> pulumi.Output[Optional[Sequence['outputs.VappAccessControlSharedWith']]]:
        """
        one or more blocks defining a subject to which we are sharing. 
        See shared_with below for detail. It cannot be used if `shared_with_everyone` is set.
        """
        return pulumi.get(self, "shared_withs")

    @property
    @pulumi.getter(name="vappId")
    def vapp_id(self) -> pulumi.Output[str]:
        """
        A unique identifier for the vApp.
        """
        return pulumi.get(self, "vapp_id")

    @property
    @pulumi.getter
    def vdc(self) -> pulumi.Output[Optional[str]]:
        """
        The name of organization to which the vApp belongs. Optional if defined at provider level.
        """
        return pulumi.get(self, "vdc")

